SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkAuditorEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	/*
	SELECT * 
		INTO TMP_AUDITOR_EVALUATION_PLAN
		FROM [dbo].[#AuditorEvaluationPlanTemp]
		
	SELECT *
		INTO #AuditorEvaluationPlanTemp
		FROM TMP_AUDITOR_EVALUATION_PLAN
	

	-- SELECT * FROM TMP_AUDITOR_EVALUATION_PLAN
	-- SELECT * FROM dbo.[#AuditorEvaluationPlanTemp]
	RAISERROR('DATABASE_ERROR_DEBUGGING', 16, 16)
	*/

	-- ACTUALIZAMOS LOS REGISTROS QUE YA EXISTAN BD
	UPDATE AEP
		SET AEP.[InteractionOrigin] = TMP_AEP.[InteractionOrigin],
			AEP.[InteractionFormat] = TMP_AEP.[InteractionFormat],
			AEP.[ContactId] = TMP_AEP.[InteractionContactId],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		INNER JOIN [#AuditorEvaluationPlanTemp] TMP_AEP
			ON AEP.[Instance] = TMP_AEP.[VCC]
				AND TMP_AEP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND TMP_AEP.[AuditorId] = AEP.[IdAuditor]
				AND TMP_AEP.[InteractionId] = AEP.[IdInteraction]
				AND TMP_AEP.[AgentId] = AEP.[IdAgent]
				AND TMP_AEP.[InteractionType] = AEP.[InteractionType]

	-- VOLCAMOS LOS REGISTROS QUE NO EXISTAN EN LA BD
	;WITH CTE_NEW_AUDITOR_EVALUATION_PLAN AS (
		SELECT TMP_AEP.* 
			FROM [#AuditorEvaluationPlanTemp] TMP_AEP
			LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON AEP.[Instance] = TMP_AEP.[VCC]
					AND AEP.[IdEvaluationPlan] = TMP_AEP.[EvaluationPlanId]
					AND AEP.[IdAuditor] = TMP_AEP.[AuditorId]
					AND AEP.[IdInteraction] = TMP_AEP.[InteractionId]
					AND AEP.[IdAgent] = TMP_AEP.[AgentId]
					AND AEP.[InteractionType] = TMP_AEP.[InteractionType]
			WHERE AEP.[Instance] IS NULL 
	)
		-- INSERTMAOS LA DATA EN LA TABLA AEP
		INSERT INTO [dbo].[AuditorEvaluationPlan] (
				[Instance], [IdEvaluationPlan], [idCampaign], [IdAgent], [IdAuditor],
				[IdInteraction], [InteractionType], [InteractionDate], [InteractionDateEnd], [InteractionDuration],
				[ManagementResult], [InteractionOrigin], [InteractionFormat], [ContactId], [ContactAddress], 
				[ContactName], [Status], [StatusDescription], [Completed], [Score],
				[CreatedByUserId], [CreatedDate], [TimeStamp]
			)
			SELECT CTE_AEP.[VCC], CTE_AEP.[EvaluationPlanId], ISNULL(CTE_AEP.[CampaignId], ''), CTE_AEP.[AgentId], CTE_AEP.[AuditorId],
					CTE_AEP.[InteractionId], CTE_AEP.[InteractionType], CTE_AEP.[InteractionStartDate], CTE_AEP.[InteractionEndDate], CTE_AEP.[InteractionDuration],
					CTE_AEP.[InteractionManagementResult], CTE_AEP.[InteractionOrigin], CTE_AEP.[InteractionFormat], CTE_AEP.[InteractionContactId], CTE_AEP.[InteractionContactAddress],
					CTE_AEP.[InteractionContactName], 1, 'NEW', 0, 0,
					'system', GETUTCDATE(), GETUTCDATE()
				FROM CTE_NEW_AUDITOR_EVALUATION_PLAN CTE_AEP 


	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#AuditorEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
