SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkInteractionQuery]
AS
BEGIN
	SET NOCOUNT ON

	INSERT INTO [dbo].[AudioQuery]
		([VCC]
		  ,[ProcessId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[LastModifiedDate]
		  )
	SELECT DISTINCT
		A.[VCC]
		,A.[ProcessId]
		,A.[AudioId]
		,A.[Section]
		,A.[Part]
		,A.[QueryId]
		,GETUTCDATE()
	FROM [dbo].[#InteractionQueryTemp] A
	LEFT JOIN [AudioQuery] B (NOLOCK) ON A.[VCC] = B.[VCC]
		AND A.[ProcessId] = B.[ProcessId] 
		AND A.[AudioId] = B.[AudioId]
		AND A.[Section] = B.[Section]
		AND A.[Part] = B.[Part]
		AND A.[QueryId] = B.[QueryId]
	INNER JOIN [dbo].[ProcessAudio] C ON A.[VCC] = C.[VCC]
		AND A.[ProcessId] = C.[ProcessId]
		AND A.[ProcessId] = C.[ProcessId] 
		AND A.[AudioId] = C.[AudioId]
		AND ISNULL(A.[Section],0) = C.[Section]
		AND ISNULL(A.[Part],0) = C.[Part]
	WHERE B.[ProcessId] IS NULL

	DROP TABLE [dbo].[#InteractionQueryTemp]

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
