SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkTipificationInteraction]
AS
BEGIN
	SET NOCOUNT ON
	
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT TIT_TMP.[VCC],
						TIT_TMP.[EvaluationPlanId]		'EVALUATION_PLAN_ID'
			FROM [#TipificationInteractionTemp] TIT_TMP (NOLOCK)
			WHERE TIT_TMP.[VCC] IS NOT NULL 
				AND TIT_TMP.[EvaluationPlanId] IS NOT NULL

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationTipificationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
			
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	
	-- ACTUALIZAMOS LOS REGISTROS CORRESPONDIENTES A LA TABLA TEMPORAL SOLO EN EL CAMPO ISCHECKED
	UPDATE ET
		SET ET.[IsChecked] = TIT_TMP.[IsChecked]
		FROM [EvaluationTipification] ET
		INNER JOIN  [#TipificationInteractionTemp] TIT_TMP (NOLOCK)
			ON TIT_TMP .[VCC] = ET.[VCC]
				AND TIT_TMP.[AbilityId] = ET.[AbilityId]
				AND TIT_TMP.[ScoreId] = ET.[ScoreId]
				AND TIT_TMP.[ID] = ET.[ID]
				AND TIT_TMP.[EvaluationPlanId] = ET.[EvaluationPlanId]
				AND TIT_TMP.[InteractionId] = ET.[InteractionId]
		
	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [dbo].[#TipificationInteractionTemp];
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
