SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE procedure [dbo].[CleanFailedEvaluationPlanData](
@VCC VARCHAR(50),
@idEvaluationPlan VARCHAR(50)
)
AS
BEGIN

SET NOCOUNT ON

	-- Verifica que exista el proceso para eliminar.
	IF EXISTS(SELECT [ID] FROM [dbo].[EvaluationPlan] WHERE [Instance] = @VCC AND [ID] = @idEvaluationPlan)
	BEGIN

	DELETE FROM InteractionEvaluationPlan WHERE IdEvaluationPlan = @idEvaluationPlan AND Instance = @VCC
	DELETE FROM AuditorEvaluationPlan WHERE IdEvaluationPlan = @idEvaluationPlan AND Instance = @VCC
	DELETE FROM EvaluationPlan WHERE id = @idEvaluationPlan AND Instance = @VCC

	--eliminar historicos generados

	DELETE FROM [dbo].[HistoricEvaluationFormat] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricGroup] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricSubGroup] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricAbility] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricAbilityEvaluationFormat] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricAbilityQuery] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricAbilityQueryEntity] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricEvaluationFormatCustomField] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricCustomField] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricCustomFieldResult] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricEvaluationFormatAttachedSignature] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC
	DELETE FROM [dbo].[HistoricCampaignEvaluationFormat] WHERE EvaluationPlanId = @idEvaluationPlan AND VCC = @VCC	
	
	SELECT 1 AS 'result'
	END
	ELSE
	BEGIN
		SELECT 0 AS 'result'
	END		



END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
