SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteAbilities] (
	@Instance Varchar(50) = NULL,
	@AbilityIDs Varchar(MAX) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
		
    DECLARE @_IDS TABLE(ID VARCHAR(50))

    INSERT INTO @_IDS SELECT [Value] FROM [dbo].[Split](@AbilityIDs,',')

    -- ELIMINAMOS LO ITEMS ASOCIADOS A LOS SCORES
    DECLARE RECURRENT_CURSOR CURSOR 
    LOCAL STATIC READ_ONLY FORWARD_ONLY
    FOR 
    -- SELECCIONAMOS LOS VCC EXISTENTES
    SELECT [ID]
        FROM [Score]
        WHERE [Instance] = @Instance
            AND  [IdAbility] IN (SELECT [ID] FROM @_IDS)
    
    -- DECLARARAMOS UNA VARIABLE PARA INDICAR EL SCORE ACTUAL QUE ESTAMOS ELIMINANDO
    DECLARE @CURRENT_SCORE_TO_REMOVE VARCHAR(50) = ''

    -- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
    OPEN RECURRENT_CURSOR

    FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_SCORE_TO_REMOVE
    WHILE @@FETCH_STATUS = 0
    BEGIN
        -- ELIMINAMOS LOS REGISTROS DE SCORETIPIFICATION
        DELETE [ScoreTipificationItem] 
            WHERE [VCC] = @Instance
                AND [ScoreId] = @CURRENT_SCORE_TO_REMOVE

        -- ELIMINAMOS LOS REGISTROS DE SCORETIPIFICATION
        DELETE [ScoreTipification] 
            WHERE [VCC] = @Instance
                AND [ScoreId] = @CURRENT_SCORE_TO_REMOVE

        -- ELIMINAMOS LOS REGISTROS DE SCORE
        DELETE [Score]
            WHERE [Instance] = @Instance
                AND  [IdAbility] IN (SELECT [ID] FROM @_IDS)
                
        FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_SCORE_TO_REMOVE
    END
    CLOSE RECURRENT_CURSOR
    DEALLOCATE RECURRENT_CURSOR

    -- ELIMINAMOS LOS REGISTROS ABILITYQUERY
    DELETE [AbilityQuery] 
        WHERE [VCC] = @Instance 
            AND  [AbilityId] IN (SELECT [ID] FROM @_IDS)

    -- ELIMINAMOS EL REGISTRO ABILITY
    DELETE [Ability] 
        WHERE [Instance] = @Instance
            AND [ID] IN (SELECT [ID] FROM @_IDS)

    DELETE [AbilityScoreCard] 
        WHERE [VCC] = @Instance
            AND [ID] IN (SELECT [ID] FROM @_IDS)

    SELECT 1 AS 'result'
       
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
