SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteAbilityQueries] (
	@VCC VARCHAR(50) = NULL, 
	@AbilityId VARCHAR(100) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON;

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
        
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS VCC QUE ACTUALIZAREMOS
		DECLARE RECURRENT_CURSOR CURSOR 
		LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			-- SELECCIONAMOS LOS ABILITY_QUERY RELACIONADOS AL ABILITY
			SELECT AQ.[ID]
				FROM [dbo].[AbilityQuery] AQ (NOLOCK) 
				WHERE AQ.[VCC] = @VCC 
					AND AQ.[AbilityId] = @AbilityId

		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS ACTUALIZANDO
		DECLARE @CURRENT_ABILITY_ID VARCHAR(50) = ''

		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
		OPEN RECURRENT_CURSOR
		FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_ABILITY_ID
		WHILE @@FETCH_STATUS = 0
		BEGIN 

			-- ELIMINAMOS LOS ABILITY_QUERY_ENTITY QUE COINCIDEN CON EL ABILITY_QUERY_ID ACTUAL
			DELETE FROM [dbo].[AbilityQueryEntity]
				WHERE [AbilityQueryId] = @CURRENT_ABILITY_ID

			FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_ABILITY_ID
		END
		CLOSE RECURRENT_CURSOR
		DEALLOCATE RECURRENT_CURSOR

		-- SP PARA ELIMINAR TODAS LAS ABILITY_QUERIES
		DELETE FROM [dbo].[AbilityQuery] 
			WHERE [VCC] = @VCC 
				AND [AbilityId] = @AbilityId
		
		SELECT 1 AS 'result'
    
		SET NOCOUNT OFF

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
	
	SET NOCOUNT OFF

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
