SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Section				INT = NULL,
	@Part					INT = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
		
		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
		DELETE FROM [dbo].[Audio] 
			WHERE [VCC] = @VCC
				AND [ID] = @InteractionId
				AND [Section] = @Section
				AND [Part] = @Part

		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA PROCESSAUDIO
		DELETE FROM [dbo].[ProcessAudio]
			WHERE [VCC] = @VCC
				AND [AudioId] = @InteractionId
				AND [Section] = @Section
				AND [Part] = @Part 

		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA INTERACTIONEVALUATIONPLAN
		DELETE FROM [dbo].[InteractionEvaluationPlan] 
			WHERE [Instance] = @VCC
				AND [IdInteraction] = @InteractionId
				AND [InteractionSection] = @Section
				AND [InteractionPart] = @Part 

		/*
		-- ELIMINAMOS LA INTERACCION DE LA TABLA AUSITOREVALUATIONPLAN
		DELETE FROM [dbo].[AuditorEvaluationPlan]
			WHERE [Instance] = @VCC
				AND [IdInteraction] = @InteractionId
		*/

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
