SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteIntent] (
    @VCC Varchar(50) = NULL,
    @AppId VARCHAR(100) = NULL,
    @IntentId Varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

    -- ELIMINAMOS EL INTENT DE LA TABLA INTENT
    DELETE FROM [Intent]
    WHERE [VCC] = @VCC
      AND [AppId] = @AppId
      AND [IntentId] = @IntentId

    -- ELIMINAMOS LOS UTTERANCES REGISTRADOS CON EL APPID E INTENTID
    DELETE FROM [Utterance]
    WHERE [VCC] = @VCC
      AND [AppId] = @AppId
      AND [IntentId] = @IntentId
    --ELIMINAR UNDERLINED
    DELETE UL FROM [dbo].[Intent] I
                       JOIN [dbo].[Utterance] U
                            ON I.[VCC] = U.[VCC]
                                AND I.[AppId] = U.[AppId]
                       JOIN [dbo].[Underlined] UL
                            ON UL.[VCC] = U.[VCC]
                                AND UL.[UtteranceId]= U.[Id]
    WHERE I.[IntentId] = @IntentId AND I.[AppId] = @AppId AND I.[VCC] = @VCC
    --ELIMINAR UtteranceEntity
    DELETE UE
    FROM [dbo].[Intent] I
             JOIN [dbo].[Entity] E
                  ON I.[VCC] = E.[VCC]
                      AND I.[AppId] = E.[AppId]
             JOIN [dbo].[Utterance] U
                  ON I.[VCC] = U.[VCC]
                      AND I.[AppId] = U.[AppId]
             JOIN [dbo].[UtteranceEntity] UE
                  ON UE.[VCC] = U.[VCC]
                      AND UE.[UtteranceId]= U.[Id]
                      AND UE.[EntityName] = E.[Name]
    WHERE I.[IntentId] = @IntentId AND I.[AppId] = @AppId AND I.[VCC] = @VCC

    --Marco el NLU como pendiente de entrenamiento
    UPDATE
        [dbo].[NLU]
    SET
        [NeedTrain] = 1
    WHERE
            [VCC] = @VCC AND [AppId] = @AppId

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
