SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[DeleteMultipleUtterances] (
	@VCC		VARCHAR(50) = NULL,
	@Ids		VARCHAR(MAX) = NULL,
	@DeleteByIntent BIT = 1
)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @_IDS TABLE(
	 ID VARCHAR(50)
	)
	DECLARE @UTTERANCES TABLE(
	ID VARCHAR(50)
	)
	DECLARE @APPIDS TABLE(
	 ID VARCHAR(50)
	)
	
	INSERT INTO @_IDS SELECT [Value] FROM [dbo].[Split](@Ids,',')
	
	IF(@DeleteByIntent = 1)
	BEGIN 
		INSERT INTO @UTTERANCES 
		SELECT 
		U.[Id] 
		FROM [dbo].[Utterance] U (NOLOCK)
		JOIN [dbo].[Underlined] UN (NOLOCK)
		ON U.[VCC] = UN.[VCC] AND U.[Id] = UN.[UtteranceId]
		WHERE U.[VCC] = @VCC AND U.[IntentId] IN(SELECT [ID] FROM @_IDS)
	
	   INSERT INTO @APPIDS 
	   SELECT [AppId] 
	   FROM [dbo].[Intent] 
	   WHERE [VCC] = @VCC 
	   AND [IntentId] IN(SELECT [ID] FROM @_IDS)
	   
	END
	ELSE
	BEGIN 
	
		INSERT INTO @UTTERANCES SELECT [ID] FROM @_IDS
		
		INSERT INTO @APPIDS 
		   SELECT [AppId] 
		   FROM [dbo].[Utterance] 
		   WHERE [VCC] = @VCC 
		   AND [Id] IN(SELECT [ID] FROM @_IDS)
	
	END

	
	
	
	
	DELETE [dbo].[Utterance] WHERE [VCC] = @VCC AND [Id] IN(SELECT [ID] FROM @UTTERANCES)
	
	DELETE [dbo].[UtteranceEntity] WHERE [VCC] = @VCC AND [UtteranceId] IN(SELECT [ID] FROM @UTTERANCES)
			
	DELETE FROM [dbo].[Underlined] WHERE [VCC] = @VCC AND  [UtteranceId] IN(SELECT [ID] FROM @UTTERANCES)

    UPDATE [dbo].[NLU] SET 
    [IsPublished] = 0, 
    [LastPublishedDate] = NULL, 
    [IsTrained] = 0, 
    [LastTrainedDate] = NULL
    WHERE [AppId] IN(SELECT [ID] FROM @APPIDS)
    
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
