SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetAbility] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT A.[ID]							'id',
			A.[Title]							'title',
			A.[Detail]						'detail',
			N.[Culture]						'culture',
			A.[Type]							'type',
			A.[CalificationType]				'calificationType',
			A.[AnalysisType]					'analysisType',
			A.[Binary]						'binary',
			A.[NotApply]						'notApply',
			A.[Distribute]					'distribute',
			A.[AcceptComments]				'acceptComments',
			A.[CreatedDate]					'createdDate',
			A.[CreatedByUserId]				'createdByUserId',
			A.[LastModifiedDate]				'lastModifiedDate',
			A.[LastModifiedByUserId]			'lastModifiedByUserId',
			A.[Enabled]						'enabled',
			A.[Query]							'query',
			A.[QueryName]                     'queryName',
			A.[Language]						'language',
			A.[IsNegative]                    'isNegative',
            AC.[DegradeScoreCard]             'degradeScoreCard'
		FROM [dbo].[Ability] A (NOLOCK)
		LEFT JOIN [dbo].[NLU] N (NOLOCK)
			ON N.[VCC] = A.[Instance]
				AND N.[Name] = SUBSTRING(A.[Query], 0, CHARINDEX('|', A.[Query]))
        LEFT JOIN [dbo].[AbilityScoreCard] AC 
            ON AC.[VCC] = A.[Instance] 
                AND AC.[ID] = A.[ID]       
		WHERE A.[Instance] = @Instance
			AND A.[ID] = @ID

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
