SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAbilityQueries] (
	@VCC              VARCHAR(50) = NULL, 
	@AbilityId        VARCHAR(100) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
    
    DECLARE @QUERY VARCHAR(MAX) = ''
    
    SET @QUERY += 'SELECT [AQ].[ID]											''id'',
					[AQ].[QueryId]											''queryId'',
					[AQ].[QueryContent]										''queryContent'',
					[AQ].[AcceptancePercentage]								''acceptancePercentage'',
					ISNULL([AQ].[AcceptancePercentage], 0) * 100			''acceptanceInteger'',
					[AQ].[Order]										    ''order'' FROM '
    IF(@EvaluationPlanId IS NOT NULL AND @EvaluationPlanId <> '')
    BEGIN
	    SET @QUERY += ' [dbo].[HistoricAbilityQuery] AQ (NOLOCK) WHERE [AQ].[VCC] = '''+@VCC+
					  '''AND [AQ].[AbilityId] ='''+ @AbilityId+''' AND AQ.[EvaluationPlanId] = '''+@EvaluationPlanId+''''		
    END
    ELSE
    BEGIN	
	    SET @QUERY += ' [dbo].[AbilityQuery] AQ (NOLOCK) WHERE [AQ].[VCC] = '''+@VCC+
					  '''AND [AQ].[AbilityId] ='''+ @AbilityId+''''
    END

	SET @QUERY += ' ORDER BY [AQ].[Order] ASC'
	EXEC(@QUERY)
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
