SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetAbilitys] (
	@Instance VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL, 
	@Disabled BIT = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT A.[ID]								'id',
			A.[Title]							'title',
			A.[Detail]							'detail',
			A.[Type]							'type',
			A.[CalificationType]				'calificationType',
			A.[Binary]							'binary',
			A.[NotApply]						'notApply',
			A.[AcceptComments]					'acceptComments',
			A.[Enabled]							'enabled',
			A.[Query]							'query',
			A.[Queryname]						'queryName',
			N.[Culture]							'culture',
			A.[CreatedDate]						'createdDate',
			A.[CreatedByUserId]					'createdByUserId',
			A.[LastModifiedDate]  				'lastModifiedDate',
			A.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM Ability a (NOLOCK)
		LEFT JOIN [dbo].[NLU] N (NOLOCK)
			ON N.[VCC] = A.[Instance]
				AND N.[Name] = SUBSTRING(A.[Query], 0, CHARINDEX('|', A.[Query]))
		WHERE a.Instance = @Instance
			AND ISNULL(a.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL(a.Title, '') LIKE CASE WHEN @SearchCriteria = 'title' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
			AND ISNULL(a.Detail, '') LIKE CASE WHEN @SearchCriteria = 'detail' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
			AND ISNULL(@Disabled, 0) <> [Enabled]
		ORDER BY a.[Title]

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
