SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[GetAgentQualificationAverage] (
	@Instance Varchar(50) = NULL,
	@IdAgent Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		ERAQS.EvaluationResultAgentQualificationSum/ERAQ.EvaluationResultAgentQuantity AgentQualificationAverage
	FROM
		(
			-- EvaluationResultAgentQualificationSum
			SELECT
				SUM([QualificationSum]) EvaluationResultAgentQualificationSum
			FROM
				(
					SELECT
						SUM([Qualification]) QualificationSum
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdAgent]= @IdAgent
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction]
				) EvaluationResultAgent
		) ERAQS,
		(
			-- EvaluationResultAgentQuantity
			SELECT
				COUNT(*) EvaluationResultAgentQuantity
			FROM
				(
					SELECT
						[IdAgent]
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdAgent]= @IdAgent
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction]
				) EvaluationResultAgent
		) ERAQ

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
