SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAllegroAgents] (
	@Ip VARCHAR(50), 
	@VCC VARCHAR(50), 
	@Type INT, 
	@Campaigns VARCHAR(MAX) = NULL
) AS
BEGIN
	-- ESTE SP RETORNA LA LISTA DE AGENTES DEL VCC SEGUN LAS CAMPANAS

	-- DECLARAMOS VARIABLES PARA ARMAR LA CONSULTA
	DECLARE @SQL VARCHAR(MAX) = NULL
	DECLARE @TABLE_MMPRODAT VARCHAR(100) = NULL

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF @Type = 0
	BEGIN  
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END

	-- ARMAMOS LA QUERY optimizada para agentes sin linea asignada
	SET @Sql = '
		SELECT U.[VCC]								''vcc'',
				UC.[CampaignId]						''campaignId'',
				U.[Id]								''userId'',
				U.[Name]							''userName'',
				A.[WorkgroupId]						''workGroupId''
			FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
			LEFT JOIN ' + @TABLE_MMPRODAT + '[GroupApplication] GA (NOLOCK)
				ON (
						GA.[VCC] = U.[VCC]
						OR
						GA.[VCC] = ''system''
					)
					AND GA.[GroupId] = U.[UserGroup]
			LEFT JOIN ' + @TABLE_MMPRODAT + '[Agent] A (NOLOCK)
				ON A.[VCC] = U.[VCC]
					AND A.[UserId] = U.[Id] 
			LEFT JOIN ' + @TABLE_MMPRODAT + '[UserCampaign] UC (NOLOCK) 
				ON UC.VCC = U.[VCC] 
					AND UC.[UserId] = U.[Id] 
			WHERE U.[VCC] = ''' + @VCC + '''
				AND GA.ApplicationId = ''baragent'' '

	/*
	-- ARMAMOS LA QUERY
	SET @Sql = '
		SET NOCOUNT ON
		SELECT UC.[VCC]							''vcc'',
				UC.[CampaignId]						''campaignId'',
				UC.[UserId]							''userId'',
				U.[Name]							''userName'',
				A.[WorkgroupId]						''workGroupId''
			FROM ' + @TABLE_MMPRODAT + '[Agent]  A (NOLOCK)
			LEFT JOIN ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
				ON U.[VCC] = A.[VCC]
					AND U.[Id] = A.[UserId]
			LEFT JOIN ' + @TABLE_MMPRODAT + '[UserCampaign] UC (NOLOCK) 
				ON UC.VCC = A.VCC 
					AND UC.UserId = A.UserId
			WHERE UC.[VCC] = ''' + @VCC + ''''
	*/

	IF @Campaigns IS NOT NULL AND @Campaigns <> ''
		SET @Sql += 'AND UC.[CampaignId] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '

	SET @Sql += ' 
		SET NOCOUNT OFF'

	-- select @Sql
	EXEC (@Sql)

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
