SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAllegroInteractionVideos]
(
	@Ip						VARCHAR(50) = NULL,
	@VCC					VARCHAR(50) = NULL,
	@Type					INT = 0,
	@InteractionIds         VARCHAR(250) = NULL -- EN CASO SE CAMBIE LA BUSQUEDA A VARIOS IDS, CAMBIAR A VARCHAR(MAX)
)
AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)

	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	DECLARE @VIDEO_FORMATS VARCHAR(25) = 'mp4'

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @HISTORICALDATA_TABLE_REF VARCHAR(50) = NULL
    
	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @HISTORICALDATA_TABLE_REF = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICALDATA_TABLE_REF = '[HistoricalData].[dbo].'
	END

	-- SE ARMA EL QUERY PRINCIPAL PARA LA BUSQUEDA DE INTERACCIONES Y TIEMPO TOTAL
	SET @SQL = '
		SELECT ID.[VirtualCC]														''vcc'', 
				ID.[Id]																''id'',
				IMP.[Section]														''section'',
				IMP.[Part]															''part'',
				IMP.[Format]														''format''
			FROM ' + @HISTORICALDATA_TABLE_REF + '[InteractionDetail] ID (NOLOCK)
			INNER JOIN ' + @HISTORICALDATA_TABLE_REF + '[InteractionMultimediaParts] IMP (NOLOCK)
				ON IMP.[Id] = ID.[Id]
			WHERE ID.[VirtualCC] = ''' + @VCC + '''
				AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','',''))
				AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @VIDEO_FORMATS + ''','','')) '

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL)

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
