SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetCognitiveInteractionIntents]
(
@IdInteraction VARCHAR(100),
@Section VARCHAR(50),
@Part VARCHAR(50),
@Vcc VARCHAR(50),
@TypeProcessResult VARCHAR(50),
@ProcessResult VARCHAR(50)
)
AS
BEGIN

	IF (@TypeProcessResult = 'EvaluationPlan')
	BEGIN
		SELECT DISTINCT
		NI.[VCC]				'vcc',
		NI.[Name]				'intentName',
		NI.[IntentId]			'intentId',
		NI.[AppId]				'appId',
		NI.[CognitiveEngine]	'cognitiveEngine',
		NI.[nluId]				'modelName'

		FROM InteractionEvaluationPlan  IEP 
		INNER JOIN EvaluationResult ER ON IEP.Instance = ER.Instance AND IEP.IdInteraction = ER.IdInteraction
		INNER JOIN EvaluationPlan EP ON IEP.IdEvaluationPlan = EP.ID
		INNER JOIN EvaluationFormat EF ON EP.IdEvaluationFormat = EF.ID
		INNER JOIN AbilityEvaluationFormat AEF ON EF.ID = AEF.IdEvaluationFormat
		INNER JOIN AbilityQuery AQ ON AEF.IdAbility = AQ.AbilityId
		INNER JOIN (
		SELECT DISTINCT
						INNER_N.[VCC]								'vcc'
						,INNER_N.[Name] + '|'+ INNER_I.[Name]		'cognitiveId'
						,INNER_N.[Name]								'nluId'
						,INNER_N.[AppId]							'appId'
						,INNER_I.[IntentId]							'intentId'
						,INNER_I.[Name]
						,INNER_N.[CognitiveEngine]					'cognitiveEngine'	

					FROM [dbo].[NLU] INNER_N (NOLOCK)
					INNER JOIN [dbo].[Intent] INNER_I (NOLOCK) 
					ON INNER_N.[VCC] = INNER_I.[VCC]
							AND INNER_N.AppId = INNER_I.[AppId] 
					WHERE INNER_N.[VCC] = @Vcc
		) NI ON NI.vcc =AQ.VCC AND NI.cognitiveId =AQ.QueryContent

		WHERE IEP.IdInteraction = @IdInteraction and
		IEP.InteractionSection =  @Section and
		IEP.InteractionPart = @Part and 
		IEP.instance = @Vcc and 
		IEP.IdEvaluationPlan = @ProcessResult

	END

	ELSE --Es un estudio
	BEGIN
	SELECT DISTINCT	
	            TTI.[VCC]											'vcc',	
				NI.[Name]											'intentName',
				NI.[intentId]										'intentId',
				TTI.[VCC]+'::'+ NI.[nluId]							'appId',			
				NI.[cognitiveEngine]								'cognitiveEngine',
				NI.[nluId]											'modelName'	
				
				FROM StudyResultSummary SR 
				INNER JOIN StudyResultSummaryDetail SRD ON SR.StudyId =SRD.StudyId
				INNER JOIN TemplateTheme TT ON SR.TemplateId = TT.TemplateId
				INNER JOIN TemplateThemeItem TTI ON TT.TemplateId = TTI.TemplateId
				INNER JOIN (
				SELECT DISTINCT
						INNER_N.[VCC]								'vcc'
						,INNER_N.[Name] + '|'+ INNER_I.[Name]		'cognitiveId'
						,INNER_N.[Name]								'nluId'
						,INNER_N.[AppId]							'appId'
						,INNER_I.[IntentId]							'intentId'
						,INNER_I.[Name]
						,INNER_N.[CognitiveEngine]					'cognitiveEngine'	

					FROM [dbo].[NLU] INNER_N (NOLOCK)
					INNER JOIN [dbo].[Intent] INNER_I (NOLOCK) 
					ON INNER_N.[VCC] = INNER_I.[VCC]
							AND INNER_N.AppId = INNER_I.[AppId] 
					WHERE INNER_N.[VCC] = @Vcc
				) NI ON NI.[vcc] = TT.[VCC] AND NI.[cognitiveId] = TTI.[ID]
				WHERE 
				SR.StudyId = @ProcessResult AND
				SR.VCC = @Vcc AND
				SRD.TranscriptionId = @IdInteraction +'_'+@Section+'_'+@part	
		
	END

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
