SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetCustomFieldsUsage] 
	@VCC VARCHAR(50) = NULL, 				
	@CustomFieldIds VARCHAR(MAX) = NULL
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    DECLARE @_IDS TABLE(
	 ID VARCHAR(50)
	)

    INSERT INTO @_IDS SELECT [Value] FROM [dbo].[Split](@CustomFieldIds,',')

    SELECT  DISTINCT EFCF.[CustomFieldId] 'customFieldId'
        FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
        WHERE EFCF.[VCC] = @VCC 
            AND EFCF.[CustomFieldId]  IN (SELECT [ID] FROM @_IDS)
           
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
