SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetDictionaryWords] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL,
	@DictionaryId VARCHAR(50) = NULL
) AS
BEGIN
	DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @FILTER           VARCHAR(MAX) = ''
	DECLARE  @ORDER_BY         VARCHAR(MAX) = ''
	
	SET NOCOUNT ON

	SET @SQL = '
	SELECT [VCC]							''vcc'',
			[DictionaryId]					''dictionaryId'',
			[ID]							''id'',
			[word]							''word'',
			[CreatedDate]					''createdDate'',
			[CreatedByUserId]				''createdByUserId'',
			[LastModifiedDate]				''lastModifiedDate'',
			[LastModifiedByUserId]			''lastModifiedByUserId''
		FROM [dbo].[DictionaryWord] (NOLOCK) ' 

	SET @FILTER = '
		WHERE [VCC] = ''' + @VCC + ''' 
			AND [DictionaryId] = ''' + @DictionaryId + ''' '

	IF (@SearchCriteria IS NOT NULL AND @SearchCriteria <> '' AND @SearchExpression IS NOT NULL AND @SearchExpression <> '')
	BEGIN 
	    SET @FILTER += '
			AND ISNULL([Word], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''word'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
	END

	SET @ORDER_BY = ' ORDER BY [LastModifiedDate] ASC, [Word] DESC'

	SET @SQL += @FILTER + @ORDER_BY
	SET NOCOUNT OFF

	EXEC(@SQL)

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
