SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEfectivityPlansAuditor] (
	@Instance VARCHAR(50) = NULL,
	@UserId VARCHAR(50) = NULL,
	@Campaigns VARCHAR(MAX) = NULL,	
	@EvaluationPlans VARCHAR(MAX) = NULL,	
	@Completed BIT = NULL,
	@UserFunction VARCHAR(50) = NULL,	
	@EfectivityPlans VARCHAR(MAX) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @USER_ROLE VARCHAR(50) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''	
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''	
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''	
	DECLARE @SQL_SELECT_2 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM_2 VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER_2 VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA_2 VARCHAR(MAX) = ''

	--VARIABLES PARA EFECTIVIDAD
	DECLARE @SQL_SELECT_1_EFECTIVITY VARCHAR(MAX) = ''
	DECLARE @SQL_FROM_EFECTIVITY VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER_EFECTIVITY VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA_EFECTIVITY VARCHAR(MAX) = ''
	

	-- ARMAMOS EL SELECT DE LA QUERY
    
	SET @SQL_SELECT_1_EFECTIVITY += '
		SELECT EP.[ID]																								''id'', 
				ERE.[EfectivityPlanId]																				''efectivityPlanId'',
				EP.[Description]																					''description'',				
				EP.[IdEvaluationFormat]																				''idEvaluationFormat'',
				COUNT(DISTINCT ERE.[InteractionId])																	''totalInteraction'',
				COUNT(DISTINCT CASE ERE.[EfectivityStatus]  WHEN ''COMPLETED'' THEN ERE.[InteractionId] ELSE NULL END)					''completedInteraction'',
				COUNT(DISTINCT ERE.[InteractionId]) -COUNT(DISTINCT CASE ERE.[EfectivityStatus]  WHEN ''COMPLETED'' THEN ERE.[InteractionId] ELSE NULL END)  ''pendingInteraction''
				'
				

    
	SET @SQL_FROM_EFECTIVITY +='
			FROM [EvaluationPlan] EP (NOLOCK)
			INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
				ON (AEP.[Instance] = EP.[Instance] 
					AND AEP.[IdEvaluationPlan] = EP.[ID])
			INNER JOIN ( SELECT DISTINCT [VCC],[InteractionId],[AgentId],[EfectivityPlanId],[EvaluationPlanId],[AuditorId],[EfectivityStatus] FROM [dbo].[EvaluationResultEfectivity] 
						 WHERE [VCC] =' +''''+ @Instance +'''' +

			')AS ERE ON 
				(AEP.[Instance] = ERE.[VCC] 
					AND AEP.[IdEvaluationPlan] = ERE.[EvaluationPlanId]
					AND AEP.[IdInteraction] = ERE.[InteractionId])'

	-- HACEMOS EL FILTRADO SEGUN EL ROL DEL USUARIO
	IF @UserFunction = 'auditor'
	BEGIN
		SET @SQL_FROM_EFECTIVITY += '
					AND ERE.[AuditorId] = ''' + @UserId + ''''
	END
	ELSE IF (@UserFunction = 'admin')
	BEGIN	
		SET @SQL_FROM_EFECTIVITY += ')'
	END
	ELSE 
	BEGIN		
		SET @SQL_FROM_EFECTIVITY += '
					AND ERE.[AuditorId] = ''' + @UserId + ''') '
	END 

	
     SET @SQL_FILTER_EFECTIVITY += '
			WHERE EP.[Instance] = ''' + @Instance + '''				
				AND EP.[Enabled] = 1 
				AND (
					(
						EP.[Evaluation_Mode] = ''X'' 
						AND 
						(
							EP.[Status] = 7
							OR
							EP.[Status] = 8
						)
					)
					OR
					(EP.[Evaluation_Mode] = ''A'')
				) '
				
					
				

	IF (@Campaigns IS NOT NULL AND @Campaigns <> '')
	BEGIN
		
		SET @SQL_FILTER_EFECTIVITY += '
				AND EP.[IdEvaluationFormat] IN (
					SELECT CEF.[IdEvaluationFormat] FROM CampaignEvaluationFormat CEF 
						WHERE CEF.[Instance] = ''' + @Instance + '''
							AND CEF.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','',''))) '
	END

	IF (@EvaluationPlans IS NOT NULL AND @EvaluationPlans <> '') SET @SQL_FILTER += 'AND EP.[ID] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationPlans + ''','','')) '
	IF (@EfectivityPlans IS NOT NULL AND @EfectivityPlans <> '') SET @SQL_FILTER_EFECTIVITY += 'AND ERE.[EfectivityPlanId] IN (SELECT Value FROM [dbo].[split](''' + @EfectivityPlans + ''','','')) '
	
	-- VARIABLE PARA FILTRAR SOLO LOS REGISTROS DE AUDITOREVALUATIONPLAN CON [COMPLETED] = 1
	IF (@Completed = 1)
	BEGIN
		SET @SQL_FILTER += 'AND AEP.[Completed] = 1 '
		SET @SQL_FILTER_2 = ' '
	END
	ELSE 
	BEGIN
		-- SI NO LLEGA UN VALOR PARA EVALUATION PLANS, BUSCAMOS SOLO LOS QUE TIENEN INTERACCIONES PENDIENTES
		IF (@EfectivityPlans IS NULL OR @EfectivityPlans = '')
		BEGIN
		
			SET @SQL_FILTER_2 = 'WHERE X.[pendingInteraction] > 0 '
		END
	END
	

	
	SET @SQL_EXTRA_EFECTIVITY += '
			GROUP BY EP.[ID],
						ERE.[EfectivityPlanId],
						EP.[Modality],
						EP.[DateFin],
						EP.[CreatedDate],
						EP.[IdEvaluationFormat],
						EP.[Description]'

		SET @SQL_SELECT_1_EFECTIVITY += @SQL_FROM_EFECTIVITY + @SQL_FILTER_EFECTIVITY + @SQL_EXTRA_EFECTIVITY
		
		SET @SQL_SELECT_2 = 'SELECT * '
		SET @SQL_FROM_2 = 'FROM (' + @SQL_SELECT_1_EFECTIVITY + ') AS X '
	
		SET @SQL_EXTRA_2 = 'ORDER BY X.[Description] ASC'

		SET @SQL_SELECT_2 += @SQL_FROM_2 + @SQL_FILTER_2 + @SQL_EXTRA_2

		--PRINT @SQL_SELECT_2;
		EXEC (@SQL_SELECT_2)

	
	
	SET NOCOUNT OFF
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
