SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEntities] (
	@VCC VARCHAR(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL,
	@Entities VARCHAR(MAX)
) AS
BEGIN
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId

	SET @SQL = '
	SET NOCOUNT ON
	SELECT E.[ID]							    ''id'',
			E.[Name]						    ''name'',
			E.[AppId]							''appId'',
			E.[Type]							''type'',
			E.[CreatedDate]						''createdDate'',
			E.[CreatedByUserId]					''createdByUserId'',
			E.[LastModifiedDate]				''lastModifiedDate'',
			E.[LastModifiedByUserId]			''lastModifiedByUserId'',
			E.[Status]                           ''status'',
			E.[StatusCode]                      ''statusCode''
		FROM [dbo].[Entity] E (NOLOCK)
		WHERE E.[VCC] = ''' + @VCC + ''' 
			AND E.[AppId] = ''' + @AppId + ''' '
	
	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND E.[ID] IN (''' + @Entities + ''') '
	END

	SET @SQL +=	'
			AND ISNULL(E.[Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		ORDER BY E.[LastModifiedDate] ASC, E.[Name] DESC
	'
	
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
