SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationFormatAttachedSignatures] (
	@VCC                VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL,
	@EvaluationPlanId   VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
	
    DECLARE @FIND_SYSTEM BIT = 1
    
    IF @EvaluationPlanId IS NOT NULL AND @EvaluationPlanId <> ''
    BEGIN 
		    	-- LOS FORMATOS CREADOS PREVIAMENTE A LA IMPLEMENTACION DE FIRMAS ADJUNTAS NO RETORNAN RESULTADO
			IF EXISTS(
				SELECT 1
					FROM [dbo].[HistoricEvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(
							EFAS.[VCC] = @VCC 
							AND 
							EFAS.[EvaluationFormatId] = @EvaluationFormatId 
							AND 
							EFAS.[EvaluationPlanId] = @EvaluationPlanId)
						OR
						(
							EFAS.[VCC] = 'system' 
							AND 
							EFAS.[EvaluationFormatId] IS NULL 
							AND 
							@EvaluationFormatId IS NULL
						)
					)
			)
			BEGIN
		        SET @FIND_SYSTEM = 0
		        
				SELECT --EFAS.[VCC]							'vcc',
						EFAS.[Description]					'description',
						EFAS.[EvaluationFormatId]			'evaluationFormatId',
						EFAS.[Order]						'order'
					FROM [dbo].[HistoricEvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(
							EFAS.[VCC] = @VCC 
							AND 
							EFAS.[EvaluationFormatId] = @EvaluationFormatId 
							AND 
							EFAS.[EvaluationPlanId] = @EvaluationPlanId
						)
						OR
						(
							EFAS.[VCC] = 'system' 
							AND 
							EFAS.[EvaluationFormatId] IS NULL 
							AND 
							@EvaluationFormatId IS NULL
						)
					)
					ORDER BY EFAS.[Order] ASC
			END

    END 
    ELSE 
    BEGIN 
		    	-- LOS FORMATOS CREADOS PREVIAMENTE A LA IMPLEMENTACION DE FIRMAS ADJUNTAS NO RETORNAN RESULTADO
			IF EXISTS(
				SELECT 1
					FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(
							EFAS.[VCC] = @VCC 
							AND 
							EFAS.[EvaluationFormatId] = @EvaluationFormatId
						)
						OR
						(
							EFAS.[VCC] = 'system' 
							AND 
							EFAS.[EvaluationFormatId] IS NULL 
							AND 
							@EvaluationFormatId IS NULL
						)
					)
			)
			BEGIN
		        SET @FIND_SYSTEM = 0
				SELECT --EFAS.[VCC]							'vcc',
						EFAS.[Description]					'description',
						EFAS.[EvaluationFormatId]			'evaluationFormatId',
						EFAS.[Order]						'order'
					FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(
							EFAS.[VCC] = @VCC 
							AND 
							EFAS.[EvaluationFormatId] = @EvaluationFormatId
						)
						OR
						(
							EFAS.[VCC] = 'system' 
							AND 
							EFAS.[EvaluationFormatId] IS NULL 
							AND 
							@EvaluationFormatId IS NULL
						)
					)
					ORDER BY EFAS.[Order] ASC
			END

    END
    
    
    IF(@FIND_SYSTEM = 1)
    BEGIN 
    		-- LLAMAMOS POR DEFECTO LOS REGISTROS DE SYSTEM
		SELECT EFAS.[Description]					'description',
				EFAS.[EvaluationFormatId]			'evaluationFormatId',
				EFAS.[Order]						'order'
			FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
			WHERE EFAS.[VCC] = 'system' 
				AND EFAS.[EvaluationFormatId] IS NULL
			ORDER BY EFAS.[Order] ASC
    END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
