SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationPlan] (
    @Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
)
AS
BEGIN
SET NOCOUNT ON

	SELECT
		EP.[ID]												'id',
		EP.[Modality]										'modality',
		EP.[DateFin]										'dateFin',
		EP.[IdEvaluationFormat]								'idEvaluationFormat',
		EP.[Description]									'description',
		EP.[Enabled]										'enabled',
		EP.[CreatedDate]									'createdDate',
		EP.[CreatedByUserId]								'createdByUserId',
		EP.[LastModifiedDate]								'lastModifiedDate',
		EP.[LastModifiedByUserId]							'lastModifiedByUserId',
		EP.[Status]											'status',
		EP.[StatusDescription]								'statusDescription',
		EP.[Evaluation_Mode]								'evaluation_mode',
		EP.[ProcessId]										'processId',
		EP.[EvaluationStarted]								'evaluationStarted',
		EP.[FilterByContent]								'filterByContent',
		EP.[FilterByContentPercentage]						'filterByContentPercentage',
		EP.[FilterByContentQuery]							'filterByContentQuery',
		EP.[FilterByContentQueryName]						'filterByContentQueryName',
		EP.[ProcessAndEvaluate]								'processAndEvaluate',
		EP.[TranscriptionLanguage]							'transcriptionLanguage',
		P.[DictionaryId]									'dictionaryId',
		IIF (
			P.[DictionaryId] IS NULL, 
			CONVERT(BIT, 0), 
			CONVERT(BIT, 1)
		)													'useDictionary',
		EP.[EnvironmentId]									'environmentId',
		E.[Type]											'environmentType'
	FROM [EvaluationPlan] EP (NOLOCK)
	LEFT JOIN [Environment] E (NOLOCK)
		ON E.[VCC] = EP.[Instance]
			AND E.[Name] = EP.[EnvironmentId]
	LEFT JOIN [dbo].[Process] P (NOLOCK)
		ON P.[VCC] = EP.[Instance]
			AND P.[Name] = EP.ProcessId
 	WHERE [Instance] = @Instance
		AND [ID] = @ID

SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
