SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[GetEvaluationPlanAbilityEvaluationFormats] (
	@VCC				VARCHAR(50) = NULL, 
	@EvaluationPlanId   VARCHAR(50) = NULL 
) AS
BEGIN
	SET NOCOUNT ON

	-- 
	SELECT DISTINCT HAEF.[ID]						'id',
					HAEF.[IdEvaluationFormat]		'idEvaluationFormat',
					HAEF.[IdAbility]				'idAbility',
					HA.[Title]						'titleAbility',
					HA.[Detail]						'detailAbility',
					HA.[Type]						'abilityType',
					HA.[AnalysisType]				'abilityAnalysisType',
					HA.[CalificationType]			'abilityCalificationType',
					HAEF.[IdGroup]					'idGroup',
					HG.[Description]                'descriptionGroup',
					HAEF.[IdSubGroup]				'idSubGroup',
					HSG.[Description]               'descriptionSubGroup',
					HAEF.[Penalizes]				'penalizes',
					HAEF.[Score]					'score',
					HAEF.[Order]					'order',
					HA.[NotApply]					'acceptNotApplies',
					HA.[Distribute]					'distribute',
					HA.[AcceptComments]				'acceptComments',
					HA.[Detail]						'descriptionAbility',
					HAEF.[Conditional]				'conditional',
					HA.[Query]						'abilityQuery',
					HA.QueryName					'query',
					HA.[IsNegative]                 'isNegative'
		FROM [dbo].[HistoricAbilityEvaluationFormat] HAEF (NOLOCK)
		INNER JOIN [dbo].[HistoricGroup] HG (NOLOCK)
			ON HG.[VCC] = HAEF.[VCC]
				AND HG.[EvaluationPlanId] = HAEF.[EvaluationPlanId]
				AND HG.[ID] = HAEF.[IdGroup]
		INNER JOIN [dbo].[HistoricSubGroup] HSG (NOLOCK)
			ON HSG.[VCC] = HAEF.[VCC]
				AND HSG.[EvaluationPlanId] = HAEF.[EvaluationPlanId]
				AND HSG.[ID] = HAEF.[IdSubGroup]
		INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
			ON HA.[VCC] = HAEF.[VCC]
				AND HA.[EvaluationPlanId] = HAEF.[EvaluationPlanId]
				AND HA.[ID] = HAEF.[IdAbility]
		WHERE HAEF.[VCC] = @VCC
			AND HAEF.[EvaluationPlanId]= @EvaluationPlanId
		ORDER BY [Order] ASC


	
	-- CONSULTAMOS LOS SCORES RELACIONADOS AL FORMATO
	SELECT HS.[Id]									'id',
			HS.[IdAbility]							'abilityId',
			HS.[Description]						'description',
			HS.[Value]								'value'
		FROM [dbo].[HistoricScore] HS (NOLOCK)
		WHERE HS.[VCC] = @VCC
			AND HS.[EvaluationPlanId] = @EvaluationPlanId
		ORDER BY HS.[Value] DESC



	-- CONSULTAMOS LAS TIPIFICACIONES DE LAS HABILIDADES RELACIONADAS AL FORMATO
	SELECT CAST(HEFAST.[ScoreId] AS INT)			'scoreId',
			HEFAST.[ID]								'id',
			HEFAST.[Description]					'description',
			HEFAST.[Detail]							'detail',
			HEFAST.[Order]							'order'
		FROM [dbo].[HistoricEvaluationFormatAbilityScoreTipification] HEFAST (NOLOCK)
		WHERE HEFAST.[VCC] = @VCC
			AND HEFAST.[EvaluationPlanId] = @EvaluationPlanId
		ORDER BY HEFAST.[Order] ASC



	-- CONSULTAMOS LAS QUERY DE TIPIFICACION DE LAS HABILIDADES RELACIONADAS AL FORMATO
	SELECT CAST(HEFASTQ.[ScoreId] AS INT)			'scoreId',
			HEFASTQ.[TipificationId]				'tipificationId',
			HEFASTQ.[QueryId]						'queryId',
			HEFASTQ.[QueryContent]					'queryContent',
			HEFASTQ.[AcceptancePercentage]			'acceptancePercentage',
			HEFASTQ.[AcceptancePercentage] * 100	'acceptanceInteger'
		FROM [dbo].[HistoricEvaluationFormatAbilityScoreTipificationQuery] HEFASTQ (NOLOCK)
		WHERE HEFASTQ.[VCC] = @VCC
			AND HEFASTQ.[EvaluationPlanId] = @EvaluationPlanId
			


	-- CONSULTAMOS LOS ITEMS DE TIPIFICACIONES DE LAS HABILIDADES RELACIONADAS AL FORMATO
	SELECT CAST(HEFASTI.[ScoreId] AS INT)			'scoreId',
			HEFASTI.[TipificationId]				'tipificationId',
			HEFASTI.[ID]							'id',
			HEFASTI.[SecondLevelItemId]				'secondLevelItemId',
			HEFASTI.[Description]					'description',
			HEFASTI.[Order]							'order'
		FROM [dbo].[HistoricEvaluationFormatAbilityScoreTipificationItem] HEFASTI (NOLOCK)
		WHERE HEFASTI.[VCC] = @VCC
			AND HEFASTI.[EvaluationPlanId] = @EvaluationPlanId
		ORDER BY HEFASTI.[Order] ASC
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
