SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
create PROCEDURE [dbo].[GetEvaluationPlanByProcessId] (
	@Instance           Varchar(50) = NULL,
	@ProcessId			Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT
		e.[ID]							'id',
		e.[Modality]					'modality',
		e.[DateFin]						'dateFin',
		e.CreatedDate					'createdDate',
		e.CreatedByUserId				'createdByUserId',
		e.LastModifiedDate				'lastModifiedDate',
		e.LastModifiedByUserId			'lastModifiedByUserId',
		e.Description					'description',
		e.IdEvaluationFormat            'idEvaluationFormat',
		e.Enabled						'enabled',
		e.Status						'status',
        e.Evaluation_Mode				'evaluation_mode',
        e.processId    				    'processId',
        e.FilterByContent				'filterByContent',
        e.EvaluatePercentage			'evaluatePercentage',
        e.ProcessAndEvaluate    		'processAndEvaluate'
	FROM
	    EvaluationPlan e (NOLOCK)
	WHERE
		e.Instance = @Instance
		AND e.[ProcessId] = @ProcessId
	GROUP BY e.[ID],e.[Modality],e.[DateFin],e.CreatedDate,e.CreatedByUserId,
			 e.LastModifiedDate,e.LastModifiedByUserId,e.Description,e.IdEvaluationFormat,e.Enabled, e.Status, e.Evaluation_Mode,e.processId,e.FilterByContent, e.EvaluatePercentage, e.ProcessAndEvaluate
 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
