SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]											'vcc',
					IEP.[IdAgent]										'descriptionAgent',
					''													'descriptionAuditor',
					IEP.[IdCampaign]									'descriptionCampaign',
					EP.[Description]									'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]							'dateIni',
					IEP.[InteractionDateEnd]							'dateFin',
					IEP.[IdInteraction]									'id',
					IEP.[IdAgent]										'idAgent',
					IEP.[AgentName]										'agentName',
					''													'idAuditorEvaluationPlan',
					IEP.[IdCampaign]									'idCampaign',
					IEP.[IdEvaluationPlan]								'idEvaluationPlan',
					IEP.[InteractionType]								'interactionType',
					IEP.[InteractionDuration]							'interactionTime',
					A.[DurationLinguisticTime]							'interactionValidTime',
					''													'origin',
					IEP.[InteractionMessages]							'totalMessages',
					ISNULL(A.[Number], IEP.[ContactId])					'number',
					IEP.[NeedI6Update]									'needI6Update'
					/*
					IIF (
						E.[Type] = 'i6',
						ISNULL(
							A.[NeedI6Update], 
							CAST(1 AS BIT)	
						),
						CAST(0 AS BIT)
					)													'needI6Update'
					*/

		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		LEFT JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = IEP.[Instance]
				AND E.[Name] = EP.[EnvironmentId]
		LEFT JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
