SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE  PROCEDURE [dbo].[GetEvaluationPlans] (
@Instance           Varchar(50) = NULL,
@SearchCriteria     Varchar(50) = NULL,
@SearchExpression   Varchar(50) = NULL,
@Disabled			bit = NULL
)
AS
BEGIN
SET NOCOUNT ON

	-- 
	;WITH CTE_AEP_SUMMARY AS (
		SELECT AEP.[IdEvaluationPlan]																				'evaluationPlanId',
				COUNT(AEP.[IdInteraction])																			'totalEvaluations',
				--ISNULL(sum(cast(a.Completed as int)), 0)   'completedEvaluations',
				--ISNULL(ROUND(sum(cast(a.Completed as numeric(5,2)))*100/count(a.IdInteraction),2), 0) 'completedPercentage',
				COUNT(DISTINCT CASE AEP.[Completed] WHEN 1 THEN AEP.[IdInteraction] ELSE NULL END)					'completedEvaluations',
				(
					(
						CAST(
							COUNT(DISTINCT CASE AEP.[Completed] WHEN 1 THEN AEP.[IdInteraction] ELSE NULL END)
							+ 
							COUNT(DISTINCT CASE AEP.[Status] WHEN 0 THEN AEP.[IdInteraction] ELSE NULL END)
						 AS NUMERIC(18,2)) 
					)
					/
					CASE COUNT(DISTINCT AEP.[IdInteraction]) WHEN 0 THEN 1 ELSE COUNT(DISTINCT AEP.[IdInteraction]) END 
				) * 100																								'completedPercentage'
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			WHERE AEP.[Instance] = @Instance
			GROUP BY AEP.[IdEvaluationPlan]
	)
		
	-- 
    SELECT
			e.[ID]									'id',
			e.[Modality]							'modality',
			e.[DateFin]								'dateFin',
			e.CreatedDate							'createdDate',
			e.CreatedByUserId						'createdByUserId',
			e.LastModifiedDate						'lastModifiedDate',
			e.LastModifiedByUserId					'lastModifiedByUserId',
			e.Description							'description',
			e.IdEvaluationFormat					'idEvaluationFormat',
			e.Enabled								'enabled',
			e.Status								'status',
			e.Evaluation_Mode						'evaluation_mode',
			e.processId    							'processId',
			ef.templateId    						'templateId',
			CTE_AEP_S.[totalEvaluations]			'totalEvaluations',
			CTE_AEP_S.[completedEvaluations]		'completedEvaluations',
			CTE_AEP_S.[completedPercentage]			'completedPercentage',

			/*
			count(a.IdInteraction)			'totalEvaluations',
			--ISNULL(sum(cast(a.Completed as int)), 0)   'completedEvaluations',
			--ISNULL(ROUND(sum(cast(a.Completed as numeric(5,2)))*100/count(a.IdInteraction),2), 0) 'completedPercentage',
			COUNT(DISTINCT CASE a.[Completed] WHEN 1 THEN a.[IdInteraction] ELSE NULL END)					'completedEvaluations',
			(
				(
					CAST(
						COUNT(DISTINCT CASE a.[Completed] WHEN 1 THEN a.[IdInteraction] ELSE NULL END)
						+ 
						COUNT(DISTINCT CASE a.[Status] WHEN 0 THEN a.[IdInteraction] ELSE NULL END)
					 AS NUMERIC(18,2)) 
				)
				/
				CASE COUNT(DISTINCT a.[IdInteraction]) WHEN 0 THEN 1 ELSE COUNT(DISTINCT a.[IdInteraction]) END 
			) * 100																							'completedPercentage',
			*/
			e.[Percentage]							'percentage',
			e.[StatusDescription]					'statusDescription',
			e.[BatchStatus]							'batchStatus'
		FROM EvaluationPlan e (NOLOCK)
		/*
		LEFT JOIN AuditorEvaluationPlan a (NOLOCK) 
			ON a.[Instance] = e.[Instance]
				AND a.[IdEvaluationPlan] = e.[ID]
		*/
		INNER JOIN CTE_AEP_SUMMARY CTE_AEP_S
			ON CTE_AEP_S.[evaluationPlanId] = e.[ID] 
		INNER JOIN [dbo].[EvaluationFormat] ef (NOLOCK)
			ON ef.[Instance] = e.[Instance]
				AND ef.[ID] = e.[IdEvaluationFormat]
		WHERE e.Instance = @Instance
			AND ISNULL(e.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL(e.Modality, '') LIKE CASE WHEN @SearchCriteria = 'modality' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL(@Disabled, 0) <> e.Enabled

		/*
		GROUP BY e.[ID],
					e.[Modality],
					e.[DateFin],
					e.CreatedDate,
					e.CreatedByUserId,
					e.LastModifiedDate,
					e.LastModifiedByUserId,
					e.Description,
					e.IdEvaluationFormat,
					e.Enabled, 
					e.Status, 
					e.Evaluation_Mode,
					e.processId,
					ef.templateId, 
					e.Percentage, 
					e.StatusDescription, 
					e.[BatchStatus]	
		*/

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
