SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetGlobalSearchFilters]
(
	@VCC	VARCHAR(50) = NULL
)
AS 
BEGIN
	SET NOCOUNT ON
	
	--LISTAR CAMPANIAS DISPONIBLES EN LAS TRES TABLAS PRINCIPALES
	SELECT DISTINCT [IdCampaign] 'campaignId',[IdCampaign] 'campaign' 
		FROM [dbo].[InteractionEvaluationPlan] IEP 
		INNER JOIN [dbo].[EvaluationPlan] EP 
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[Id]
		WHERE IEP.[Instance] = @VCC	
			AND EP.[Evaluation_Mode] = 'M'
			AND [IdCampaign] IS NOT NULL
	UNION
	
	SELECT DISTINCT [Campaign],[Campaign] 
		FROM [dbo].[Audio]
		WHERE [VCC] = @VCC	
			AND [Campaign] IS NOT NULL
	UNION 

	SELECT DISTINCT [Campaign],[Campaign] 
		FROM [dbo].[AsyncInteraction]
		WHERE [VCC] = @VCC	
			AND [Campaign] IS NOT NULL

	--LISTAR AGENTES DISPONIBLES EN LAS TRES TABLAS PRINCIPALES 
	SELECT DISTINCT [IdAgent] 'agentId',[AgentName] 'agent' 
		FROM [dbo].[InteractionEvaluationPlan] IEP 
		INNER JOIN [dbo].[EvaluationPlan] EP 
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[Id]
		WHERE IEP.[Instance] = @VCC	
			AND EP.[Evaluation_Mode] = 'M'	
			AND [IdCampaign] IS NOT NULL

	UNION
	
	SELECT DISTINCT [Agent],[Agent] 
		FROM [dbo].[Audio]
		WHERE [VCC] = @VCC	
			AND [Agent] IS NOT NULL
	UNION 

	SELECT DISTINCT [FirstTakedAgent],[FirstTakedAgent] 
		FROM [dbo].[AsyncInteraction]
		WHERE [VCC] = @VCC	
			AND [FirstTakedAgent] IS NOT NULL

	--LISTAR ORIGEN DE LAS INTERACCIONES
	SELECT 'Client' AS originId, 'Client' origin

	UNION

	SELECT 'Agent' AS originId, 'Agent' origin

	--LISTAR TIPIFICACIONES  
	SELECT DISTINCT [ManagementResult] 'dispositionCodeId',[ManagementResult] 'dispositionCode' 
		FROM [dbo].[InteractionEvaluationPlan] IEP
		INNER JOIN [dbo].[EvaluationPlan] EP 
			ON IEP.[Instance] = EP.[Instance]
			AND IEP.[IdEvaluationPlan] = EP.[Id]
		WHERE IEP.[Instance] = @VCC	
			AND EP.[Evaluation_Mode] = 'M'	
			AND [ManagementResult] IS NOT NULL

	UNION

	SELECT [Description],  [Description]  
		FROM [dbo].[Audio]
		WHERE VCC = @VCC
			AND [Description] IS NOT NULL
	UNION

	SELECT DISTINCT [DispositionCode],[DispositionTreePath] 
		FROM [dbo].[AsyncInteraction]
		WHERE [VCC] = @VCC
			AND  [DispositionCode] IS NOT NULL
			AND [DispositionTreePath] IS NOT  NULL

	--LISTAR CANALES DE LAS INTERACCIONES
	SELECT DISTINCT [InteractionType] 'interactionTypeId',[InteractionType] 'interactionType' 
		FROM dbo.[InteractionEvaluationPlan] IEP
		INNER JOIN [dbo].[EvaluationPlan] EP 
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[Id]
		WHERE IEP.[Instance] = @VCC	
			AND EP.[Evaluation_Mode] = 'M'
	
	UNION

	SELECT DISTINCT [Channel], [Channel] 
		FROM  [dbo].[AUDIO]
		WHERE [VCC] = @VCC

	UNION

	SELECT DISTINCT [Channel], [Channel] 
		FROM  [dbo].[AsyncInteraction]
		WHERE [VCC] = @VCC

	
	SET NOCOUNT OFF
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
