SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetGroups] (
	@Instance Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL, @Disabled bit = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		g.ID							'id',
		g.Description					'description',
		g.CreatedDate					'createdDate',
		g.CreatedByUserId				'createdByUserId',
		g.LastModifiedDate				'lastModifiedDate',
		g.LastModifiedByUserId			'lastModifiedByUserId',
		g.[Enabled]						'enabled'
	FROM [Group] g
	WHERE g.Instance = @Instance
		AND ISNULL(g.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(g.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
		AND ISNULL(@Disabled, 0) <> [Enabled]
	ORDER BY g.Description ASC

	SET NOCOUNT OFF
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
