SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- ESTE SP RETORNA LAS INTERACCIONES ASINCRONAS 
CREATE PROCEDURE [dbo].[GetI6AsyncInteractions]
(
	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@Origins				VARCHAR(MAX) = NULL,
	@InteractionIds         VARCHAR(MAX) = NULL,
    @Evaluated              VARCHAR(MAX) = NULL,
	@UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
	@ResultType				VARCHAR(50) = NULL,					-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
	@ContactAddress			VARCHAR(300) =NULL
    
)
AS
BEGIN
	-- INFO: EN CHAT SE CREAN UN ID EN CADA INTERACCION(EJM: CHATS DE ATENCION EN LAS WEB DE BANCOS), LOS DEMAS CANALES ID + ENDDATE
	
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
	DECLARE @FILTER_CONTACT_ADDRESS VARCHAR(MAX) = '';
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @HISTORICAL_DATA_I6_BD NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_APPSTORE_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CALL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CHAT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_FACEBOOK_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_INSTAGRAM_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_MAIL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TWITTER_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WEBCONTACT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WHATSAPP_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_YOUTUBE_TABLE NVARCHAR(100)

	-- DEFINIMOS EL NOMBRE DE LA BD
	SET @HISTORICAL_DATA_I6_BD = '[HistoricalDataI6]' -- BD PARA DESARROLLO
	-- SET @HISTORICAL_DATA_I6_BD = '[HistoricalDataI6]'

	-- EL PARAMETRO TYPE DEFINE SI LA BD HISTORICALDATAI6 SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE =		'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE =			'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Call]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE =			'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE =		'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE =		'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE =		'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE =			'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE =			'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE =		'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE =		'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE =			'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Youtube]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE =		@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE =			@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Call]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE =			@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE =		@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE =		@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE =		@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE =			@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE =			@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE =		@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE =		@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE =			@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Youtube]'
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT '

	-- ARMAMOS LA PARTE BASE DE FILTROS
	SET @FILTERS_FIXED_PART = ' WHERE HDI6.[Vcc] = ''' + @VCC + ''''
	
	SET @FILTERS_OPTIONAL_PART  =' AND HDI6.[EndDate] BETWEEN '''
    SET @FILTERS_OPTIONAL_PART += (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) 
    SET @FILTERS_OPTIONAL_PART  +=''' AND '''  
    SET @FILTERS_OPTIONAL_PART  +=(SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' '
    

	-- DEPENDIENDO SI LA HORA DE FIN ES MAYOR A LA DE INICIO O NO DAMOS FORMA AL FILTRO DE HORA
	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(HDI6.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(HDI6.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Campaign] IN (SELECT VALUE FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	
	IF(@ContactAddress IS NOT NULL AND @InteractionType='CHAT')
		BEGIN
			SET @FILTER_CONTACT_ADDRESS = 'CHAT'
			SET @FILTERS_OPTIONAL_PART += '
				AND ContactName LIKE ''%' + @ContactAddress + '%''
			'
		END	
	IF(@ContactAddress IS NOT NULL AND @InteractionType='MAIL')
		BEGIN
			SET @FILTER_CONTACT_ADDRESS = 'MAIL'
			SET @FILTERS_OPTIONAL_PART += '
				AND (MailFrom LIKE ''%' + @ContactAddress + '%'' OR MailFrom LIKE ''%' + @ContactAddress + '%'')
			'
		END	
	IF(@ContactAddress IS NOT NULL AND @InteractionType='WEBCONTACT')
		BEGIN
			SET @FILTER_CONTACT_ADDRESS = 'WEBCONTACT'
			SET @FILTERS_OPTIONAL_PART += '
				AND ContactName LIKE ''%' + @ContactAddress + '%''
			'
		END	
	IF(@ContactAddress IS NOT NULL AND  @FILTER_CONTACT_ADDRESS = '')
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND ContactAddress LIKE ''%' + @ContactAddress + '%''
			'
		END	

	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND (
								(HDI6.[DispositionTreePath] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','',''))) 
								OR
								(HDI6.[DispositionCode] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','','')))
							)'	

	-- ARMAMOS EL ORDER BY
	SET @SQL_EXTRA += 'ORDER BY [ID], [EndDate] DESC'

	-- ARMAMOS EL SELECT PARA LOS DIFERENTES INTERACTION TYPES
	IF (@InteractionType = 'APPSTORE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_APPSTORE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_APPSTORE
		SET @SQL_SELECT += '
								Vcc														''vcc'', 
								ID														''id'', 
								CONVERT(VARCHAR, EndDate, 23)							''folder'',
								ExportedContent											''exportedContent'', 
								''APPSTORE''											''channel'',
								Campaign												''campaign'', 
								StartDate												''startDate'', 
								EndDate													''endDate'', 
								Account													''account'', 
								Initiative												''initiative'',
								SUBSTRING(ContactName, 0, 50)							''contactName'',
								ContactAddress											''contactAddress'',
								NULL													''contactId'',
								FirstAgent												''firstTakedAgent'', 
								NULL													''lastTakedAgent'', 
								NULL													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)				''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode											''dispositionCode'', 
								DispositionTreePath										''dispositionTreePath'',
								RawChar													''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
		
	END
	ELSE IF (@InteractionType = 'CALL')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_CALL_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_CHAT
		SET @SQL_SELECT += '
								[Vcc]														''vcc'',
								[Id] + ''_0_0''												''ID'',
								[Id]														''InteractionId'',
								0															''Section'',
								0															''Part'',
								''CALL''													''Channel'',
								[ContactAddress]											''Number'',	
								[ContactAddress]											''contactAddress'',
								NULL														''contactId'',
								[ContactName]												''contactName'',
								''''														''Gender'',
								ISNULL([HoldTime], 0)										''SilenceTime'',
								ISNULL([AttentionTime], 0)									''DurationTime'', -- ESTO SE DEBE CORREGIR
								ISNULL([AttentionTime], 0)									''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
								[DispositionTreePath]										''Category1'',
								NULL														''Category2'',
								NULL														''Category3'',
								NULL														''Description'',
								[DispositionCode]											''DispositionCode'',
								[Campaign]													''Campaign'',
								[LastAgent]													''Agent'',
								NULL														''agentName'',
								CASE [Initiative] WHEN ''INBOUND'' THEN ''E''
													WHEN ''Inb.'' THEN ''E''
													WHEN ''OUTBOUND'' THEN ''S''
													WHEN ''Out.'' THEN ''S''
													ELSE NULL END							''Type'',
								CONVERT(VARCHAR, [StartDate], 120)							''StartDate'',
								CONVERT(VARCHAR, [EndDate], 120)							''EndDate'',
								''wav''														''Format'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += '[IsTaken] = 1 '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[LastAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END 
	ELSE IF (@InteractionType = 'CHAT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_CHAT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_CHAT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''CHAT''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								-- ContactName												''contactName'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								NULL														''contactAddress'',
								NULL														''contactId'',
								FirstTakeAgent												''firstTakedAgent'', 
								LastTakeAgent												''lastTakedAgent'', 
								IsTaken														''isTaken'',
								ISNULL(TRY_CAST(ChatMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND (HDI6.[FirstTakeAgent] IS NOT NULL OR HDI6.[LastTakeAgent] IS NOT NULL) '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[LastTakeAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE CHAT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @FILTERS_OPTIONAL_PART += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END 
	ELSE IF (@InteractionType = 'FACEBOOK')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_FACEBOOK_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_FACEBOOK
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''FACEBOOK''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								[ContactAddress]											''contactAddress'',
								NULL														''contactId'',								
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								NULL														''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
		
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END 
	ELSE IF (@InteractionType = 'GOOGLEPLAY')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_GOOGLEPLAY
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''GOOGLEPLAY''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'',  
								Initiative													''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								[ContactAddress]											''contactAddress'',
								NULL														''contactId'',	
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END
	ELSE IF (@InteractionType = 'INSTAGRAM')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_INSTAGRAM_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_INSTAGRAM
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''INSTAGRAM''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								ContactAddress												''contactAddress'',
								NULL														''contactId'',	
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'MAIL')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_MAIL_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_MAIL
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''MAIL''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								CASE WHEN Initiative =''INBOUND'' THEN MailFrom ELSE MailTo END ''contactAddress'',
								NULL														''contactId'',	
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								MailHasResponse												''isTaken'',
								ISNULL(TRY_CAST(MailTotalMessages AS INT), 1)				''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'TWITTER')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_TWITTER_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_TWITTER
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''TWITTER''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								ContactAddress												''contactAddress'',
								NULL														''contactId'',
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'WEBCONTACT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WEBCONTACT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WEBCONTACT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WEBCONTACT''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'', 
								NULL														''contactAddress'',
								NULL														''contactId'',
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalResponses AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE WEBCONTACT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @FILTERS_OPTIONAL_PART += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END
	ELSE IF (@InteractionType = 'WHATSAPP')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WHATSAPP_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WHATSAPP
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WHATSAPP''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''In.'' THEN ''IN''
									WHEN ''Out.'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'',
								ContactAddress												''contactAddress'',
								NULL														''contactId'',
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(WhatsappTotalMessages AS INT), 1)			''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar															''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'YOUTUBE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_YOUTUBE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_YOUTUBE
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''YOUTUBE''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								SUBSTRING(ContactName, 0, 50)								''contactName'',
								ContactAddress												''contactAddress'',
								NULL														''contactId'',
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END

    IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
        SET @FILTERS_OPTIONAL_PART = '';
	    SET @FILTERS_EXCLUDING_PART=' AND ID IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
    END
		  
	-- AGREGAMOS EL CONTADOR DE FILAR AL SELECT
	SET @SQL_SELECT += '
								,RN = ROW_NUMBER() OVER(PARTITION BY [ID], CONVERT(VARCHAR, EndDate, 23) ORDER BY [EndDate] DESC) '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @HISTORICAL_DATA_I6_TABLE + ' HDI6 (NOLOCK) '

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_INTERACTIONS
		(
			vcc VARCHAR(50), 
			id VARCHAR(250),  
			folder VARCHAR(50),
			exportedContent VARCHAR(250),  
			channel VARCHAR(50), 
			campaign VARCHAR(50), 
			startDate DATETIME,
			endDate DATETIME,
			account VARCHAR(50), 
			initiative VARCHAR(50), 
			contactName VARCHAR(250), 
			contactAddress VARCHAR(300),
			conctacId VARCHAR(50),
			firstTakedAgent VARCHAR(50), 
			lastTakedAgent VARCHAR(50), 
			isTaken VARCHAR(50), 
			totalMessages INT,
			durationTime VARCHAR(50),  
			attentionTime VARCHAR(50), 
			dispositionCode VARCHAR(250), 
			dispositionTreePath VARCHAR(250), 
			rawChar INT,
			RN INT
		)

		-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
		SET @IS_NESTED = 0

		-- PRINT 'SP NO ANIDADO'
	END
	ELSE
	BEGIN
		-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
		SET @IS_NESTED = 1

		-- PRINT 'SP ANIDADO'
	END 

	-- INSERTAMOS EL RESULTADO EN LA TABLA TEMPORAL
	print @SQL_SELECT 
	INSERT INTO #TMP_HD_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		
		EXEC (@SQL_SELECT)
   
    
    -- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
    DECLARE @QUERY                  VARCHAR(MAX) = ''
    DECLARE @QUERY_FILTER           VARCHAR(MAX) = ''
    DECLARE @QUERY_JOIN             VARCHAR(MAX) = ''
	
	-- FILTRO POR INTERACCIONES EVALUADAS O NO
	IF (@Evaluated IS NOT NULL AND @Evaluated <> '')
	    BEGIN 
		DECLARE @EvaluatedTable TABLE (Val BIT)

		INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')

		-- SOLAMENTE SI ES SI O NO
		IF ((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
		BEGIN
			IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
			BEGIN 
				SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[id] AND AEP.[Completed]=1 ) '
			END
		ELSE  --Si es No
           BEGIN
               SET @QUERY_JOIN = ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[id] AND AEP.[Completed]=1 ) '
               SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
           END
       END
       
	 END
	-- FIN FILTRO INTERACCIONES EVALUADAS


	

	-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
	IF @IS_NESTED = 0
	BEGIN
		-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
		-- IF @UniqueIds = 1 -- ENFOCADO A INTERACCIONES
		-- BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SET @QUERY = '
					SELECT HDI.[channel]										AS ''interactionType'',
							COUNT(DISTINCT (
								CASE WHEN '''+@InteractionType+''' = ''CALL'' 
								THEN HDI.[id] 
								ELSE HDI.[id] 
								-- ELSE CONCAT(HDI.[id], HDI.[endDate]) 
								END))											AS ''interactions'',
							COUNT(*)											AS ''details'',
							SUM(HDI.[rawChar])									AS ''rawChars''
						FROM #TMP_HD_INTERACTIONS HDI '
				SET @QUERY += @QUERY_JOIN
				SET @QUERY += ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel]'
				
			END
			/*
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY = '
					SELECT HDI.[vcc]											AS ''vcc'',
							HDI.[channel]										AS ''interactionType'',
							HDI.[campaign]										AS ''campaign'',
							HDI.[id]											AS ''id'',
							HDI.[firstTakedAgent]								AS ''agent'',
							HDI.[initiative]									AS ''origin'',
							SUM(HDI.[rawChar])									AS ''rawChar''
						FROM #TMP_HD_INTERACTIONS HDI '
				SET @QUERY += @QUERY_JOIN
				
				SET @QUERY += ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + '
					GROUP BY HDI.[vcc], HDI.[channel], HDI.[campaign], HDI.[id], HDI.[firstTakedAgent], HDI.[initiative]'
			END
			--EJECUTAR CONSULTA
			EXEC (@QUERY)
			
		END
		ELSE -- ENFOCADO A DETALLES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
			SET @QUERY = '
				SELECT HDI.[channel]											AS ''interactionType'',
						COUNT(DISTINCT (
							CASE WHEN '''+@InteractionType +'''= ''CALL'' 
							THEN HDI.[id] 
							ELSE CONCAT(HDI.[id], HDI.[endDate]) 
							END))												AS ''interactions'',
						COUNT(*)												AS ''details'',
						SUM(HDI.[rawChar])										AS ''rawChar''
					FROM #TMP_HD_INTERACTIONS HDI '
			SET @QUERY += @QUERY_JOIN
					
			SET @QUERY += '	WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel] '
			
			END
			*/
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
			    SET @QUERY = ' SELECT HDI.* FROM #TMP_HD_INTERACTIONS HDI ' + @QUERY_JOIN +  ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER
			END 
			-- EJECUTAR CONSULTA
			print @QUERY
			EXEC (@QUERY)
		-- END
	END


	/*
	-- DECLARAMOS LAS CTE
	WITH CTE_AVAILABLE_BALANCE_REPORT AS (
		SELECT * FROM #TMP_HD_INTERACTIONS
	)
	select * from CTE_AVAILABLE_BALANCE_REPORT 
	*/
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
