SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetI6InteractionAudios] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL
) AS 
BEGIN
	-- RETORNAMOS LOS REGISTROS DE AMBAS TABLAS
	;WITH CTE_ALL_RECORDS AS (
		-- BUSCAMOS LOS AUDIOS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Section]								'section',
						[Part]									'part',
						[Agent]									'agentId',
						[Format]								'format'
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
		UNION
		SELECT DISTINCT [IdInteraction]							'id',
						[InteractionSection]					'section',
						[InteractionPart]						'part',
						[IdAgent]								'agentId',
						[InteractionFormat]						'format'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
	),
	CTE_SUMMARY AS (
		SELECT *,
				RN = ROW_NUMBER() OVER(PARTITION BY CTE_AR.[id],
													CTE_AR.[section],
													CTE_AR.[part]
											ORDER BY CTE_AR.[id] ASC, 
													CTE_AR.[section] ASC,
													CTE_AR.[part] ASC,
													CTE_AR.[agentId] DESC,
													CTE_AR.[format] DESC
										) 
			 FROM CTE_ALL_RECORDS CTE_AR
	)
		SELECT CTE_S.[id], 
				CTE_S.[section],
				CTE_S.[part],
				CTE_S.[agentId],
				CTE_S.[format] 
			FROM CTE_SUMMARY CTE_S
			WHERE RN = 1

	/*
	-- DECLARAMOS VARIABLES PARA ALMACENAR LAS CANTIDADES DE REGISTROS
	DECLARE @AUDIO_RECORDS INT = 0
	DECLARE @INTERACION_EVALUATION_PLAN_RECORDS INT = 0

	SELECT @AUDIO_RECORDS = COUNT(*)
		FROM [dbo].[Audio] A (NOLOCK)
		WHERE A.[VCC] = @VCC
			AND A.[ID] = @InteractionId
			AND A.[NeedI6Update] = 0

	SELECT @INTERACION_EVALUATION_PLAN_RECORDS = COUNT(DISTINCT CONCAT(IEP.[IdInteraction], '_', IEP.[InteractionSection], '_', IEP.[InteractionPart]))
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE IEP.[Instance] = @VCC	
			AND IEP.[IdInteraction] = @InteractionId
			AND IEP.[NeedI6Update] = 0

	IF @AUDIO_RECORDS >= @INTERACION_EVALUATION_PLAN_RECORDS
	BEGIN

		-- BUSCAMOS LOS AUDIOS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Section]								'section',
						[Part]									'part',
						[Agent]									'agentId',
						[Format]								'format'
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
				AND A.[NeedI6Update] = 0
			ORDER BY A.[Section] ASC,  A.[Part] ASC
	END
	ELSE
	BEGIN
		SELECT DISTINCT [IdInteraction]							'id',
						[InteractionSection]					'section',
						[InteractionPart]						'part',
						[IdAgent]								'agentId',
						[InteractionFormat]						'format'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
				AND IEP.[NeedI6Update] = 0
			ORDER by IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC
	END
	*/
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
