SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetI6InteractionMessages] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL
) AS 
BEGIN
	-- RETORNAMOS LOS REGISTROS DE AMBAS TABLAS
	;WITH CTE_ALL_RECORDS AS (
		-- BUSCAMOS LOS REGISTROS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Campaign]								'campaign',
						[Folder]								'folder',
						[LastTakedAgent]						'agentId'
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
		UNION
		SELECT DISTINCT [IdInteraction]							'id',
						[IdCampaign]							'campaign',
						[FormattedEndDate]						'folder',
						[IdAgent]								'agentId'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
	),
	CTE_SUMMARY AS (
		SELECT *,
				RN = ROW_NUMBER() OVER(PARTITION BY CTE_AR.[id],
													CTE_AR.[folder],
													CTE_AR.[campaign],
													CTE_AR.[agentId]
											ORDER BY CTE_AR.[id] ASC, 
														CTE_AR.[folder] ASC,
														CTE_AR.[campaign] DESC,
														CTE_AR.[agentId] DESC
										) 
			 FROM CTE_ALL_RECORDS CTE_AR
	)
		SELECT CTE_S.[id], 
				CTE_S.[folder],
				CTE_S.[campaign],
				CTE_S.[agentId] 
			FROM CTE_SUMMARY CTE_S
			WHERE RN = 1

	/*
	-- DECLARAMOS VARIABLES PARA ALMACENAR LAS CANTIDADES DE REGISTROS
	DECLARE @MESSAGES_RECORDS INT = 0
	DECLARE @INTERACION_EVALUATION_PLAN_RECORDS INT = 0

	SELECT @MESSAGES_RECORDS = COUNT(*)
		FROM [dbo].[AsyncInteraction] AI (NOLOCK)
		WHERE AI.[VCC] = @VCC
			AND AI.[ID] = @InteractionId

	SELECT @INTERACION_EVALUATION_PLAN_RECORDS = COUNT(DISTINCT CONCAT(IEP.[IdInteraction], '_', IEP.[IdCampaign], '_', IEP.[FormattedEndDate]))
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE IEP.[Instance] = @VCC	
			AND IEP.[IdInteraction] = @InteractionId

	IF @MESSAGES_RECORDS >= @INTERACION_EVALUATION_PLAN_RECORDS
	BEGIN
		-- BUSCAMOS LOS REGISTROS DE LA INTERACCION
		SELECT DISTINCT [ID]									'id',
						[Campaign]								'campaign',
						[Folder]								'folder',
						[LastTakedAgent]						'agentId'
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
			ORDER BY AI.[Folder] ASC
	END 
	ELSE 
	BEGIN
		SELECT DISTINCT [IdInteraction]							'id',
						[IdCampaign]							'campaign',
						[FormattedEndDate]						'folder',
						[IdAgent]								'agentId'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
			ORDER by IEP.[FormattedEndDate] ASC
	END
	*/
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
