SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetIntents] (
	@VCC Varchar(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Intents NVARCHAR(MAX)
	)
AS
BEGIN
	
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId
	
	SET @SQL = '
	SET NOCOUNT ON
	SELECT  IT.[Name]						    ''name'',
	        IT.[AppId]                          ''appId'',
			IT.[IntentId]						''intentId'',
			IT.[Color]							''color'',
			IT.[CreatedDate]					''createdDate'',
			IT.[CreatedByUserId]				''createdByUserId'',
			IT.[LastModifiedDate]				''lastModifiedDate'',
			IT.[LastModifiedByUserId]			''lastModifiedByUserId'',
			IT.[Status]                         ''status'',
			IT.[StatusCode]                     ''statusCode'',
			COUNT(U.[IntentId])				    ''totalUtterances''
		FROM [dbo].[Intent] IT (NOLOCK) 
		LEFT JOIN [dbo].[Utterance] U (NOLOCK) 
			ON IT.[VCC] = U.[VCC]
				AND IT.[IntentId] = U.[IntentId]
		WHERE IT.[VCC] = ''' + @VCC + '''
			AND IT.[AppId] = ''' + @AppId + ''' '

	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND IT.[IntentId] IN (''' + @Intents + ''') '
	END

	IF @SearchCriteria IS NOT NULL AND @SearchExpression IS NOT NULL
	BEGIN
		SET @SQL +=	'
			AND ISNULL(IT.[Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END '
	END

	SET @SQL +=	'
		GROUP BY IT.[IntentId]
				,IT.[Name]
				,IT.[AppId]
				,IT.[Color]
				,IT.[CreatedDate]
				,IT.[CreatedByUserId]
				,IT.[LastModifiedDate]
				,IT.[LastModifiedByUserId]
				,IT.[Status]  
				,IT.[StatusCode] 
		ORDER BY IT.[LastModifiedDate] ASC, IT.[Name] DESC '

	SET @SQL += ' 
	SET NOCOUNT OFF'

	EXEC(@SQL)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
