SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetInteractionQueryResults] (
	@VCC VARCHAR(50) = NULL,
	@TransactionType VARCHAR(50) = NULL, 
	@TransactionId VARCHAR(50) = NULL, 
	@InteractionType VARCHAR(10) = NULL,  
	@InteractionId VARCHAR(250) = NULL, 
	@Campaign VARCHAR(100) = NULL,  
	@Folder VARCHAR(50) = NULL
) 
AS 
BEGIN 
    SET NOCOUNT ON

	-- HACEMOS LA BUQUEDA SEGUN EL TIPO DE INTERACCION
	IF @InteractionType = 'CALL'
		BEGIN
			SELECT IQR.[InteractionId]				'interactionId',
					IQR.[Section]					'section',
					IQR.[Part]						'part',
					IQR.[InteractionType]			'interactionType',
					IQR.[BatchType]					'transactionType',
					IQR.[BatchTypeId]				'transactionId',
					IQR.[BatchTypeName]				'transactionName',
					IQR.[AnalysisType]				'analysisType',
					IQR.[QueryId]					'queryId',
					IQR.[QueryName]					'queryName',
					IQR.[QueryValue]				'queryValue',
					IQR.[QueryData]					'queryData',
					IQR.[Matches]					'matches',
					IQR.[Details]					'details'
				FROM [dbo].[InteractionQueryResult] IQR (NOLOCK)
				WHERE IQR.[VCC] = @VCC
					AND IQR.[InteractionType] = @InteractionType
					AND (
						IQR.[InteractionId] = @InteractionId		-- GUID BASICO DE 32 CARACTERES APROXIMADAMENTE
						OR
						IQR.[TranscriptionId] = @InteractionId		-- GUID BASICO + SECTION + PART
					)
		END
		ELSE
		BEGIN
			SELECT IQR.[InteractionId]				'interactionId',
					IQR.[Section]					'section',
					IQR.[Part]						'part',
					IQR.[InteractionType]			'interactionType',
					IQR.[BatchType]					'transactionType',
					IQR.[BatchTypeId]				'transactionId',
					IQR.[BatchTypeName]				'transactionName',
					IQR.[AnalysisType]				'analysisType',
					IQR.[QueryId]					'queryId',
					IQR.[QueryName]					'queryName',
					IQR.[QueryValue]				'queryValue',
					IQR.[QueryData]					'queryData',
					IQR.[Matches]					'matches',
					IQR.[Details]					'details'
				FROM [dbo].[InteractionQueryResult] IQR (NOLOCK)
				WHERE IQR.[VCC] = @VCC
					AND IQR.[InteractionType] = @InteractionType
					AND (
						IQR.[InteractionId] = @InteractionId
						OR
						IQR.[TranscriptionId] = CONCAT(@InteractionType, '_', @Campaign, '_', @Folder, '_', REPLACE(@InteractionId, ':', '_'))
					)
		END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
