SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetInteractionsEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL/*,
	@IdAuditor Varchar(50) = NULL*/
	)
AS
BEGIN
	SET NOCOUNT ON
	SELECT
		IEP.[IdInteraction]					'id',
		IEP.[IdCampaign]					'idCampaign',
		IEP.[IdCampaign]					'descriptionCampaign',
		IEP.[IdAgent]						'idAgent',
		IEP.[IdAgent]						'descriptionAgent',
		IEP.[InteractionDateStart]			'dateIni',
		IEP.[InteractionDateEnd]			'dateFin',
		IEP.[InteractionDuration]			'interactionTime',
		/*IEP.[Evaluated]					'evaluated',*/
		IEP.[InteractionType]				'interactionType',
		IEP.[ManagementResult]				'dispositionCode',
		IEP.[ContactId]						'contactName',
		IEP.[InteractionOrigin]				'origin',
		IEP.[ContactAddress]				'contactAddress'
	FROM [InteractionEvaluationPlan] IEP (NOLOCK)
	WHERE [Instance] = @Instance
		AND [IdEvaluationPlan] = @IdEvaluationPlan
	ORDER BY IEP.[CreatedDate],
				IEP.[InteractionDateEnd] DESC,
				IEP.[IdEvaluationPlan],
				IEP.[IdInteraction]

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
