SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--exec [GetLinguisticProcessStatus] 'inconcert','radion1'
CREATE PROCEDURE [dbo].[GetLinguisticProcessStatus] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		P.[VCC]																													'vcc',
		P.[Name]																												'processId',
		(CASE WHEN P.[Status] IS NULL THEN 'UNKNOWN' ELSE P.[Status] END)														'status',
		COUNT(A.[ID])																											'toTranscribe',
		SUM(CASE WHEN A.[IsTranscribed] = 1 THEN 1 ELSE 0 END)																	'transcribed',
		CAST(ROUND((SUM(CASE WHEN A.[IsTranscribed] = 1 THEN 1 ELSE 0 END) * 1.0/COUNT(*)) * 100, 3) AS NUMERIC(6,3))			'percentage',
		P.[QueryId]																												'queryId'
	FROM [Process] P (NOLOCK)
	LEFT JOIN [ProcessAudio] PA (NOLOCK) ON P.[Name] = PA.[ProcessId]
	LEFT JOIN [Audio] A (NOLOCK) ON PA.[AudioId] = A.[ID] AND PA.[Section] = A.[Section] AND PA.[Part] = A.[Part]
	WHERE P.[VCC] = @VCC
	AND P.[Name] = @Name
	GROUP BY P.[VCC], P.[Name], P.[Status], [QueryId]
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
