SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetNLUs] (
    @VCC Varchar(50) = NULL,
    @SearchCriteria Varchar(50) = NULL,
    @SearchExpression Varchar(50) = NULL,
    @Apps NVARCHAR(MAX),
    @IsSystemApp BIT = NULL,
    @ShowInMigrationProcess BIT = 0
)
AS
BEGIN
    -- EN CASO EL FLAG LLEGUE NULL LO SETTEAMOS COMO 0

    DECLARE  @SQL              NVARCHAR(MAX)
    DECLARE  @FILTER           VARCHAR(MAX) = ''
    DECLARE  @UNION_SQL        VARCHAR(MAX) = ''
    DECLARE  @APPS_FILTER      VARCHAR(MAX) = ''
    DECLARE  @STATUS_FILTER    VARCHAR(MAX) = ''
    DECLARE  @ORDER_BY         VARCHAR(MAX) = ''
    SET NOCOUNT ON
    --Status va ha cambiar a 9 o 10 de acuerdo a LastPublishedDate
    --0 PENDIENTE DE MIGRACION
    --1 ESTA DISPONIBLE EN EL MOTOR
    --2 MIGRANDO
    --3 CON ERROR ( EL ERROR LO INDICA STATUSCODE)
    --4 CANCELADO POR DEMASIADOS INTENTOS ERRONEOS
    --8 MIGRADO EL NLU PERO FALTA LOS INTENT, UTTERANCES,ETC
    --9 ESTA DISPONILBE EL MODELO EN EL MOTOR PERO NO ESTA ENTRENADO(RASA) O LUIS(PUBLICADO)
    --10 ESTA DISPONIBLE EN EL MOTOR Y ENTRENADO
    --11 EN PROCESO DE ENTRENAMIENTO (PROCESO INTERNO DE LUIS)
    --12 EN PROCESO DE PUBLICACION (PROCESO INTERNO DE LUIS)
    --13 ENTRENAMIENTO FALLIDO (LUIS RETORNO ESTADO DE ERROR LUEGO DE VARIAS CONSULTAS)
    --Se establece estos valores porque actualmente Status puede tener valores de 0 a 4, sin embargo puede ampliarse en futuros requerimientos.
    SET @SQL = '
    SELECT [VCC]                  ''vcc'',
       [Name]                 ''name'',
       [CognitiveEngine]      ''cognitiveEngine'',
       [Culture]              ''culture'',
       [Description]          ''description'',
       [AppId]                ''appId'',
       [SubscriptionKey]      ''subscriptionKey'',
       [IsSystemApp]          ''isSystemApp'',
       [NeedTrain]            ''needTrain'',
       [IsTrained]            ''isTrained'',
       [LastTrainedDate]      ''lastTrainedDateTime'',
       [IsPublished]          ''isPublished'',
       [LastPublishedDate]    ''lastPublishedDateTime'',
       [CreatedDate]          ''createdDate'',
       [CreatedByUserId]      ''createdByUserId'',
       [LastModifiedDate]     ''lastModifiedDate'',
       [LastModifiedByUserId] ''lastModifiedByUserId'',
       CASE
           WHEN [Status] = 0 THEN
               ''PENDING''
           WHEN [Status] = 1 THEN
               CASE
                   WHEN [NeedTrain] = 1 OR [LastTrainedDate] IS NULL THEN
                       ''NEED_TRAIN''
                   WHEN [NeedTrain] = 0 AND ([NeedPublish] = 1 OR [LastPublishedDate] IS NULL) THEN
                       IIF([CognitiveEngine] = ''LUIS'', ''NEED_PUBLISH'', ''NEED_TRAIN'')
                   ELSE
                       ''AVAILABLE''
                END
           WHEN [Status] = 2 THEN
                ''MIGRATING''
           WHEN [Status] = 3 THEN
               ''FAILED''
           WHEN [Status] = 4 THEN
               ''CANCELLED''
           WHEN [Status] = 8 THEN
               ''INCOMPLETE''
           WHEN [Status] = 9 THEN
                IIF([CognitiveEngine] = ''LUIS'', ''NEED_PUBLISH'', ''NEED_TRAIN'')
           WHEN [Status] = 10 THEN
                ''AVAILABLE''
           WHEN [Status] = 11 THEN
               ''TRAINING''
           WHEN [Status] = 12 THEN
               ''PUBLISHING''
           WHEN [Status] = 13 THEN
               ''TRAINING_FAILED''
           ELSE
                ''UNKNOWN''
        END ''statusCode''
    FROM [NLU] (NOLOCK)
    WHERE '

    -- EN CASO BUSQUEMOS MODELOS DE TODOS LOS VCC
    IF (@VCC = 'ALL')
        SET @SQL += '
            [VCC] IS NOT NULL '
    ELSE
        SET @SQL += '
        [VCC] = ''' + @VCC + ''' '


    -- EN CASO BUSQUEMOS MODELOS DEL SISTEMA NO FILTRAMOS POR NOMBRES
    IF @IsSystemApp = 0 AND @Apps IS NOT NULL AND @Apps <> ''
        SET @APPS_FILTER  += ' AND [AppId] IN (''' + @Apps + ''') '



    SET @FILTER += ' AND [IsSystemApp] = ' + CASE WHEN @IsSystemApp = 1 THEN '1' ELSE '0' END + ' '

    IF(@SearchCriteria IS NOT NULL AND @SearchCriteria <> '' AND @SearchExpression IS NOT NULL AND @SearchExpression <> '')
        BEGIN
            SET @FILTER += '
        AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
        AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
        AND ISNULL([LastModifiedByUserId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''LastModifiedByUserId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
        END


    SET @ORDER_BY = ' ORDER BY [LastModifiedDate] ASC, [Name] DESC'
    SET @STATUS_FILTER = ' AND [Status] = 1 '

    IF(@ShowInMigrationProcess IS NOT NULL AND @ShowInMigrationProcess = 1)
        BEGIN
            SET @UNION_SQL = ' UNION ' + @SQL + @FILTER + ' AND [Status] <> 1 '
        END


    SET @SQL += @FILTER + @APPS_FILTER + @STATUS_FILTER + @UNION_SQL +  @ORDER_BY
    SET NOCOUNT OFF

    EXEC(@SQL)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
