SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [GetPendingAudios] 'allegro', 'procesoftp06', 'ftp'
CREATE PROCEDURE [dbo].[GetPendingAudios]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@EnvironmentType	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	IF(@EnvironmentType = 'ftp' OR @EnvironmentType = 'sftp')
	BEGIN
		SELECT
			CASE CONCAT(A.[Section], '_', A.[Part]) WHEN '0_0' THEN A.[ID] ELSE A.[ID] + '_' + CONVERT(VARCHAR(10), A.[Section]) + '_' + CONVERT(VARCHAR(10), A.[Part]) END		'ID',
			NULL						'Number',	
			''							'Gender',
			A.[SilenceTime]				'SilenceTime',
			A.[DurationTime]			'DurationTime',
			''							'Category1',
			''							'Category2',
			''							'Category3',
			''							'Description',
			A.[Campaign]				'Campaign',
			A.[Agent]					'Agent',
			A.[Type]					'Type',
			CONVERT(VARCHAR, A.[StartDate], 113)			'StartDate',
			CONVERT(VARCHAR, A.[EndDate], 113)				'EndDate',
			ISNULL(A.[DispositionCode], 0)		'DispositionCode'
		FROM
			[dbo].[ProcessAudio] PA WITH (NOLOCK)
			INNER JOIN [dbo].[Audio] A WITH (NOLOCK) ON CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		WHERE
			A.[VCC] = @VCC AND PA.[ProcessId] = @ProcessId
	END
	ELSE
	BEGIN
		SELECT
			A.[ID] + '_' + CONVERT(VARCHAR(10), A.[Section]) + '_' + CONVERT(VARCHAR(10), A.[Part])		'ID',
			NULL						'Number',	
			''							'Gender',
			A.[SilenceTime]				'SilenceTime',
			A.[DurationTime]			'DurationTime',
			''							'Category1',
			''							'Category2',
			''							'Category3',
			''							'Description',
			A.[Campaign]				'Campaign',
			A.[Agent]					'Agent',
			A.[Type]					'Type',
			CONVERT(VARCHAR, A.[StartDate], 113)			'StartDate',
			CONVERT(VARCHAR, A.[EndDate], 113)				'EndDate',
			ISNULL(A.[DispositionCode], 0)		'DispositionCode'
		FROM
			[dbo].[ProcessAudio] PA WITH (NOLOCK)
			INNER JOIN [dbo].[Audio] A WITH (NOLOCK) ON PA.[AudioId] = A.[ID]
		WHERE
			A.[VCC] = @VCC AND PA.[ProcessId] = @ProcessId
	END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
