SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--exec [GetProcess] 'inconcert','test'
CREATE PROCEDURE [dbo].[GetProcess] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @TOTAL_INTERACTIONS_TO_I6_UPDATE INT = 0
	
	-- CONSULTAMOS CUANTAS INTERACCIONES CALL QUE NECESITAN ACTUALIZACION I6
	SET @TOTAL_INTERACTIONS_TO_I6_UPDATE += (
		SELECT COUNT(*)
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[ID] IN (
				SELECT PA.[AudioId] FROM [dbo].[ProcessAudio] PA WHERE PA.[ProcessId] = @Name
			)
			AND A.[NeedI6Update] = 1
	)

	-- CONSULTAMOS CUANTAS INTERACCIONES TEXT QUE NECESITAN ACTUALIZACION I6
	SET @TOTAL_INTERACTIONS_TO_I6_UPDATE += (
		SELECT COUNT(*)
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[ID] IN (
				SELECT PAI.[InteractionId] FROM [dbo].[ProcessAsyncInteraction] PAI WHERE PAI.[ProcessId] = @Name
			)
			AND AI.[NeedI6Update] = 1
	)

	-- CONSULTAMOS LA DATA DEL PROCESS
	SELECT P.[VCC]										'vcc',
			P.[Name]									'name',
			P.[Description]								'description',
			P.[ClientId]								'clientId',
			P.[Status]									'status',
			P.[Type]									'type',
			P.[StartDate]								'startDate',
			P.[EndDate]									'endDate',
			P.[MinDurationTime]							'minDurationTime',
			P.[MaxDurationTime]							'maxDurationTime',
			P.[Language]								'language',
			P.[DictionaryId]							'dictionaryId',
			IIF (
				P.[DictionaryId] IS NULL, 
				CONVERT(BIT, 0), 
				CONVERT(BIT, 1)
			)											'useDictionary',
			P.[Environment]								'environment',
			E.[Type]									'environmentType',
			P.[QueryId]									'queryId',
			P.[QueryDataId]								'queryDataId',
			P.[QueryDataIdDate]							'queryDataIdDate',
			P.[BatchScheduleId]							'batchScheduleId',
			IIF (
				@TOTAL_INTERACTIONS_TO_I6_UPDATE > 0,
				CONVERT(BIT, 1), 
				CONVERT(BIT, 0)
			)											'needI6Update',
			P.[CreatedDate]								'createdDate',
			P.[CreatedByUserId]							'createdByUserId',
			P.[LastModifiedDate]						'lastModifiedDate',
			P.[LastModifiedByUserId]					'lastModifiedByUserId'
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN [dbo].[Environment] E (NOLOCK)
			ON E.[VCC] = P.[VCC]
				AND E.[Name] = P.[Environment]
		WHERE P.[VCC] = @VCC
			AND P.[Name] = @Name

	EXEC [GetProcessFilters] @VCC, @Name
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
