SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetReportByDetailAgent] (@VCC varchar(50) = '', @Campaign varchar(100) = '', @Plan varchar(50) = '',
@EvaluationFormat varchar(50), @StartDate varchar(50) = '', @EndDate varchar(50) = '', @IdAuditor varchar(50) = '')
AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  
  -- GetReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro'
  SET NOCOUNT ON

  SELECT
    * INTO #TempEvaluationResult
  FROM (SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
	EP.Evaluation_Mode	
  FROM EvaluationResult ER
  LEFT JOIN EvaluationFormat EF
    ON ER.IdEvaluationFormat = EF.ID
  LEFT JOIN Ability A
    ON A.ID = ER.IdAbility
  LEFT JOIN EvaluationPlan EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [Group] GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup SGP
    ON SGP.ID = ER.IdSubGroup
  WHERE EF.Description LIKE CASE
    WHEN @EvaluationFormat <> '' THEN @EvaluationFormat
    ELSE EF.Description
  END
  AND ER.Instance LIKE CASE
    WHEN @VCC <> '' THEN @VCC
    ELSE ER.Instance
  END
  AND EP.Description LIKE CASE
    WHEN @Plan <> '' THEN @Plan
    ELSE EP.Description
  END
  AND ER.CampaignDescription LIKE CASE
    WHEN @Campaign <> '' THEN @Campaign
    ELSE ER.CampaignDescription
  END
  AND ER.IdAuditor LIKE CASE
    WHEN @IdAuditor <> '' THEN @IdAuditor
    ELSE ER.IdAuditor
  END
  AND ER.EvaluationDate >=
                          CASE
                            WHEN @StartDate <> '' THEN @StartDate
                            ELSE '19800101'
                          END
  AND ER.EvaluationDate <
                         CASE
                           WHEN @EndDate <> '' THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END) a



  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability)
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
   -- SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction'
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
      '' AS DescriptionPlan,
      '' AS DescriptionFormat,
      '' AS AgentDescription,
      '' AS CampaignDescription,
      '' AS IdInteraction,
      '' AS EvaluationDate,
      '' AS IdAuditor
  END
  SET NOCOUNT OFF

  

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
