SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetReports] (
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL, @Role Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	IF(@Role IS NULL)
	BEGIN
		IF @VCC = 'system' 
		BEGIN
			-- VOLCADO PARA LA CREACION DE VCC EN PROVISIONING
			SELECT
				[ID]								'id',
				[Description] 						'description',
				[Procedure] 						'procedure',
				[StartDate]							'startDate',
				[EndDate]							'endDate',
				[Frecuency]							'frecuency',
				[HourSpace]							'hourSpace',
				[ExactTime]							'exactTime',
				[Weekday]							'weekday',
				[DayMonth]							'dayMonth',
				[Summary]							'summary',
				[Filter]							'filter',
				[Email]								'email',
				[Type]								'type'
			FROM [Report] (NOLOCK)
			WHERE [VCC] = @VCC
			AND ISNULL([Id], '') + ' ' + ISNULL([Id], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND (
				[Type] IN (SELECT [Product] FROM VCCLicense (NOLOCK)  WHERE [VCC] = @VCC AND [Status] = 1)
					OR [Type] IN ('SHARED', 'BILLING', 'BUSINESS')
			)
		END 
		ELSE
		BEGIN
			-- VOLCADO PARA LA VISTA DE REPORTES SPEECH Y QUALITY
			SELECT
				[ID]								'id',
				[Description] 						'description',
				[Procedure] 						'procedure',
				[StartDate]							'startDate',
				[EndDate]							'endDate',
				[Frecuency]							'frecuency',
				[HourSpace]							'hourSpace',
				[ExactTime]							'exactTime',
				[Weekday]							'weekday',
				[DayMonth]							'dayMonth',
				[Summary]							'summary',
				[Filter]							'filter',
				[Email]								'email',
				[Type]								'type'
			FROM [Report] (NOLOCK)
			WHERE [VCC] = @VCC
			AND ISNULL([Id], '') + ' ' + ISNULL([Id], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND [Type] IN (SELECT [Product] FROM VCCLicense (NOLOCK)  WHERE [VCC] = @VCC AND [Status] = 1)
			OR [Type] = 'SHARED'
			/*
			AND (
				[Type] IN (SELECT [Product] FROM VCCLicense (NOLOCK)  WHERE [VCC] = @VCC AND [Status] = 1)
					OR [Type] = 'SHARED'
			)
			*/
		END
	END
	ELSE IF @Role = 'business_administrator'
	BEGIN
		SELECT [ID]									'id',
				[Description] 						'description',
				[Procedure] 						'procedure',
				[StartDate]							'startDate',
				[EndDate]							'endDate',
				[Frecuency]							'frecuency',
				[HourSpace]							'hourSpace',
				[ExactTime]							'exactTime',
				[Weekday]							'weekday',
				[DayMonth]							'dayMonth',
				[Summary]							'summary',
				[Filter]							'filter',
				[Email]								'email',
				[Type]								'type'
			FROM [Report] (NOLOCK)
			WHERE [VCC] = @VCC
			AND ISNULL([Id], '') + ' ' + ISNULL([Id], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND [Type] IN ('BUSINESS') 
	END
	ELSE IF @Role = 'provisioning'
	BEGIN 
		-- REPORTES PARA LA VISTA DEL PROVISIONING
		SELECT [ID]									'id',
				[Description] 						'description',
				[Procedure] 						'procedure',
				[StartDate]							'startDate',
				[EndDate]							'endDate',
				[Frecuency]							'frecuency',
				[HourSpace]							'hourSpace',
				[ExactTime]							'exactTime',
				[Weekday]							'weekday',
				[DayMonth]							'dayMonth',
				[Summary]							'summary',
				[Filter]							'filter',
				[Email]								'email',
				[Type]								'type'
			FROM [Report] (NOLOCK)
			WHERE [VCC] = @VCC
			AND ISNULL([Id], '') + ' ' + ISNULL([Id], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND [Type] IN ('BILLING') 
	END
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
