SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetScores] (
	@Instance Varchar(50) = NULL,
	@IdAbility Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- CONSULTAMOS LA DATA DE LOS SCORE
	SELECT [ID]										'id',
			[IdAbility]								'idAbility',
			[Description]							'description',
			[Value]									'value'
		FROM [dbo].[Score] (NOLOCK)
		WHERE [Instance] = @Instance
			AND [IdAbility] = @IdAbility
		ORDER BY [Value] DESC

	-- CONSULTAMOS LAS TIPIFICACIONES DE LOS SCORES
	SELECT CAST(ST.[ScoreId] AS INT)				'scoreId',
			ST.[ID]									'id',
			ST.[Description]						'description',
			ST.[Detail]								'detail',
			ST.[Order]								'order'
		FROM [dbo].[ScoreTipification] ST (NOLOCK)
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[Instance] = ST.[VCC]
				AND S.[ID] = ST.[ScoreId]
		WHERE S.IdAbility = @IdAbility
		ORDER BY ST.[Order] ASC

	-- CONSULTAMOS LA QUERY DE LAS TIPIFICACIONES DE LOS SCORES
	SELECT CAST(STQ.[ScoreId] AS INT)				'scoreId',
			STQ.[TipificationId]					'tipificationId',
			STQ.[QueryId]							'queryId',
			STQ.[QueryContent]						'queryContent',
			STQ.[AcceptancePercentage]				'acceptancePercentage',
			(STQ.[AcceptancePercentage] * 100)		'acceptanceInteger' 
		FROM [dbo].[ScoreTipificationQuery] STQ (NOLOCK)
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[Instance] = STQ.[VCC]
				AND S.[ID] = STQ.[ScoreId]
		WHERE S.IdAbility = @IdAbility

	-- CONSULTAMOS LOS ITEMS DE TIPIFICACIONES DE LOS SCORES
	SELECT CAST(STI.[ScoreId] AS INT)				'scoreId',
			STI.[TipificationId]					'tipificationId',
			STI.[ID]								'id',
			STI.[SecondLevelItemId]					'secondLevelItemId',
			STI.[Description]						'description',
			STI.[Order]								'order' 
		FROM [dbo].[ScoreTipificationItem] STI (NOLOCK)
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[Instance] = STI.[VCC]
				AND S.[ID] = STI.[ScoreId]
		WHERE S.IdAbility = @IdAbility
		ORDER BY STI.[Order] ASC

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
