SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetTeamPerformanceFilters] (
	@VCC VARCHAR(50) = NULL,
	@BatchType VARCHAR(50) NULL,
	@EvaluationFormatId VARCHAR(50) NULL,
	@TemplateId VARCHAR(50) NULL

)
AS
BEGIN
	SET NOCOUNT ON
	-- OBTENEMOS LOS FORMATOS DE EVALUACION PARA EL VCC 	
	IF @BatchType = 'EVALUATION_PLAN'
	BEGIN
		SELECT '' 'id','' 'description'
		UNION ALL
		SELECT DISTINCT [ID]  'id', 
						[Description] 'description' 
			FROM [dbo].[EvaluationFormat]
			WHERE [Instance] =  @VCC 

		-- OBTENEMOS LOS PLANES COMPLETADOS
		SELECT DISTINCT EP.[ID]							'id',
						EP.[Description]				'description'
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON  EP.[Instance] = AEP.[Instance]
					AND	EP.[ID] = AEP.IdEvaluationPlan
			
			WHERE EP.[Instance] = @VCC
				/*
				AND (
						EP.[Status] = 7 AND EP.Evaluation_Mode = 'A'
						OR
						AEP.[Completed] = 1 AND EP.Evaluation_Mode IN ('X','M')
					)
				*/
				AND AEP.[Completed] = 1
				AND EP.[IdEvaluationFormat] = @EvaluationFormatId
				
		  		

	
		-- OBTENEMOS LOS AGENTES 
		SELECT DISTINCT ER.[IdAgent]							'id',
						ER.[AgentDescription]					'description'
			FROM [dbo].[EvaluationResult] ER (NOLOCK)
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
			INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan]
			WHERE ER.[Instance] = @VCC
				AND (
						EP.[Status] = 7 AND EP.Evaluation_Mode = 'A'
						OR
						AEP.[Completed] = 1 AND EP.Evaluation_Mode IN ('X','M')
					)
				AND ER.[IdEvaluationFormat] = @EvaluationFormatId
		END
		ELSE
		BEGIN

		-- LISTAR TEMPLATES
			
		-- OBTENEMOS LOS ESTUDIOS COMPLETADOS
		SELECT DISTINCT S.[Name]						'id',
						S.[Name]						'name'
			FROM [dbo].[StudyResultSummaryDetail] SRSD (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK)
				ON S.[VCC] = SRSD.[VCC]
					AND S.[Name] = SRSD.[StudyId]
			WHERE S.[VCC] = @VCC
				AND S.[Type] = 'SPEECH'
				AND S.[Percentage] = 1
				AND S.[TemplateId] = @TemplateId

		END
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
