SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetTipification] (
	@VCC VARCHAR(50) = NULL, 
	@ID VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- CONSULTAMOS LA DATA PROPIA DE LA TIPIFICACION
	SELECT T.[ID]								'id',
			T.[Description]						'description',
			T.[Detail]							'detail',
			T.[CreatedDate]						'createdDate',
			T.[CreatedByUserId]					'createdByUserId',
			T.[LastModifiedDate]				'lastModifiedDate',
			T.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[Tipification] T (NOLOCK)
		WHERE T.[VCC] = @VCC
			AND T.[ID] = @ID

	-- CONSULTAMOS LA DATA QUERY DE LA TIPIFICACION
	SELECT TQ.[QueryId]							'queryId',
			TQ.[QueryContent]					'queryContent',
			TQ.[AcceptancePercentage]			'acceptancePercentage',
			(TQ.[AcceptancePercentage] * 100)	'acceptanceInteger'
		FROM [dbo].[TipificationQuery] TQ (NOLOCK)
		WHERE TQ.[VCC] = @VCC
			AND TQ.[TipificationId] = @ID

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
