SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetUniqueNLUByIntents]
(
	@VCC					VARCHAR(50),
	@TemplateId				VARCHAR(50),
	@Intents				VARCHAR(MAX)
)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DETERMINAR SI ES UN FORMATO O PLANTILLA
	DECLARE @TEMPLATE_TYPE VARCHAR(50) = NULL

	-- BUSCAMOS POR EL ID SI SE TRATA DE UNA PLANTILLA O FORMATO
	IF EXISTS (
		SELECT 1 
			FROM [dbo].[Template] T (NOLOCK)
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = T.[VCC]
					AND EF.[templateId] = T.[Name]
			WHERE T.[VCC] = @VCC
				AND T.[Name] = @TemplateId
	)
		SET @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	ELSE 
		SET @TEMPLATE_TYPE = 'TEMPLATE'

	-- ESTA FUNCION ES USADA SOLO PARA FORMATOS DE EVALUACION
	SELECT DISTINCT F.[AppId]			'appId' 
		INTO #TEMPLATE_MODELS 
		FROM [dbo].[EvaluationFormat] EF (NOLOCK)
		INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
			ON EF.[Instance] = AEF.[Instance] 
				AND EF.[ID] = AEF.[IdEvaluationFormat]
		INNER JOIN [dbo].[Ability] A (NOLOCK) 
			ON A.[Instance] = EF.[Instance]
				AND A.[ID] = AEF.IdAbility 
				AND A.[AnalysisType] IS NOT NULL 
		INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
			ON AQ.[VCC] = A.[Instance] 
				AND AQ.[AbilityId] = A.[ID] 
		INNER JOIN (
			SELECT DISTINCT
					N.[VCC]									'vcc'
					,N.[Name] + '|'+ I.[Name]				'cognitiveId'
					,N.[Name]								'nluId'
					,N.[AppId]								'appId'
					,I.[IntentId]							'intentId'
					, I.[Name]
				FROM [dbo].[NLU] N (NOLOCK)
				INNER JOIN [dbo].[Intent] I (NOLOCK) 
					ON N.[VCC] = I.[VCC]
						AND I.[AppId] = N.[AppId]
				WHERE N.[VCC] = @VCC
					AND I.[IntentId] IN (SELECT Value FROM dbo.[SplitString](@Intents, ','))
		) F 
			ON F.[VCC] = EF.[Instance] 
				AND F.[cognitiveId] = AQ.[QueryContent] 
				AND F.[intentId] = AQ.[QueryId] 
		WHERE EF.[Instance] = @VCC
			AND EF.[templateId] = @TemplateId

	-- PARA TEMPLATES DE UN FORMATO, AGREGAMOS LAS QUERY_ID (INTENTS) DE LAS TIPIFICACIONES DE 1ER NIVEL
	IF @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	BEGIN
		INSERT INTO #TEMPLATE_MODELS 
			SELECT I.[AppId]
				FROM [dbo].[EvaluationFormatAbilityScoreTipificationQuery] EFASTQ (NOLOCK)
				INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
					ON EF.[Instance] = EFASTQ.[VCC]
						AND EF.[ID] = EFASTQ.[EvaluationFormatId]
				INNER JOIN [dbo].[Intent] I (NOLOCK)
					ON I.[VCC] = EFASTQ.[VCC]
						AND I.[IntentId] = EFASTQ.[QueryId]
				WHERE EF.[templateId] = @TemplateId

	END

	-- CONSULTAMOS EL TOTAL DE LA TABLA TEMPORAL
	SELECT DISTINCT * FROM #TEMPLATE_MODELS (NOLOCK)

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
