SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
CREATE PROCEDURE [dbo].[GetUtterance]
(
	@VCC			VARCHAR(50),
	@AppId			VARCHAR(50),
	@IntentName		VARCHAR(50),
	@Text			VARCHAR(500)
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @INTENT_ID VARCHAR(50) = NULL
	SELECT @INTENT_ID = [IntentId]
		FROM [dbo].[Intent] (NOLOCK) 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [Name] = @IntentName
  
    -- BUSCAMOS LOS UTTERANCES SEGUN LOS PARAMETROS RECIBIDOS
	SELECT U.[VCC]								'vcc',
			U.[AppId]							'appId',
			U.[IntentId]						'intentId',
			I.[Name]							'intentName',
			U.[Id]								'id',
			U.[Text]							'text',
			U.[CreatedDate]						'createdDate',
			U.[CreatedByUserId]					'createdByUserId',
			U.[LastModifiedDate]				'lastModifiedDate',
			U.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[Utterance] U (NOLOCK)
		INNER JOIN [dbo].[Intent] I (NOLOCK) 
			ON I.[VCC] = U.[VCC]
				AND I.[IntentId] = U.[IntentId]
		WHERE U.[VCC] = @VCC
			AND U.[AppId] = @AppId
			AND U.[IntentId] = @INTENT_ID
			AND U.[Text] = @Text

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
