SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
CREATE PROCEDURE [GetUtterances]
(
	@VCC			  VARCHAR(50),
	@AppId			  VARCHAR(50),
	@Intent  		  VARCHAR(50),
	@SearchCriteria   VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- BUSCAMOS LOS UTTERANCES SEGUN LOS PARAMETROS RECIBIDOS
	DECLARE @QUERY VARCHAR(MAX) = ''
	SET @QUERY = 'SELECT U.[VCC]			    vcc,
			U.[AppId]							appId,
			U.[IntentId]						intentId,
			I.[Name]							intentName,
			U.[Id]								id,
			U.[Text]							text,
			U.[CreatedDate]						createdDate,
			U.[CreatedByUserId]					createdByUserId,
			U.[LastModifiedDate]				lastModifiedDate,
			U.[LastModifiedByUserId]			lastModifiedByUserId,
			U.[Status]                          status,
			U.[StatusCode]                      statusCode
		FROM [dbo].[Utterance] U (NOLOCK)
		INNER JOIN [dbo].[Intent] I (NOLOCK) 
			ON I.[VCC] = U.[VCC]
				AND I.[AppId] = U.[AppId]
				AND I.[IntentId] = U.[IntentId]
		WHERE U.[VCC] ='
		
		SET @QUERY += ''''
		SET @QUERY += @VCC
		SET @QUERY += ''''
	
	IF(@AppId IS NOT NULL AND @AppId <> '')
	BEGIN 
	     SET @QUERY += ' AND U.[AppId] ='
	     SET @QUERY += ''''
	     SET @QUERY += @AppId
	     SET @QUERY += ''''
	END
	
	IF(@Intent IS NOT NULL AND @Intent <> '')
	BEGIN 
	     SET @QUERY += ' AND I.[Name] ='
	     SET @QUERY += ''''
	     SET @QUERY += @Intent
	     SET @QUERY += ''''
	END
	
	
	IF(@SearchCriteria IS NOT NULL AND @SearchExpression IS NOT NULL AND @SearchExpression <> '')
	BEGIN
		SET @QUERY += ' AND '
		SET @QUERY += @SearchCriteria
		SET @QUERY += ' LIKE '
		SET @QUERY += ''''
		SET @QUERY += '%'
		SET @QUERY += @SearchExpression
		SET @QUERY += '%'
		SET @QUERY += ''''
	END
     EXEC(@QUERY)
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
