SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

-- [dbo].[SaveAuditor] 'allegro', 'danny.jhonston', '', null, 'analytic', '2018-01-01 00:00:00.000', null
CREATE PROCEDURE [dbo].[SaveAuditor]
(
	@Instance				VARCHAR(50),
	@ID						VARCHAR(50),
	@Description			VARCHAR(100),
	@CreatedDate			DATETIME,
	@CreatedByUserId		VARCHAR(50),
	@LastModifiedDate		DATETIME,
	@LastModifiedByUserId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[Auditor] SET
	[ID] = @ID,
	[Description] = @Description,
	[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
	[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
	[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
	[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
	[TimeStamp] = GETUTCDATE()
	WHERE
		[Instance] = @Instance
		AND [ID] = @ID

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Auditor](
			[Instance],
			[ID],
			[Description],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate],
			[LastModifiedByUserId],
			[TimeStamp]
		)
		VALUES(
			@Instance,
			@ID,
			@Description,
			@CreatedDate,
			@CreatedByUserId,
			@LastModifiedDate,
			@LastModifiedByUserId,
			GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
