SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveEntity] (
    @VCC					VARCHAR(50) = NULL,
    @AppId					VARCHAR(50) = NULL,
    @ID						VARCHAR(50) = NULL,
    @Name					VARCHAR(50) = NULL,
    @Type					VARCHAR(50) = NULL,
    @CreatedByUserId		VARCHAR(50) = NULL,
    @LastModifiedByUserId	VARCHAR(50) = NULL
) AS
BEGIN
    SET NOCOUNT ON

    UPDATE [Entity]
    SET [Name] = @Name,
        [Type] = @Type,
        [LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
        [LastModifiedDate] = GETUTCDATE(),
        [TimeStamp] = GETUTCDATE()
    WHERE [VCC] = @VCC
      AND [AppId] = @AppId
      AND [ID] = @ID
      AND [Name] = @Name

    IF @@ROWCOUNT = 0
        BEGIN
            INSERT INTO [Entity] (
                [VCC], [AppId], [ID], [Name], [Type],
                [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[Status],
                [StatusCode]
            )
            VALUES (
                       @VCC, @AppId, @ID, @Name, @Type,
                       GETUTCDATE(), @CreatedByUserId, GETUTCDATE(), @LastModifiedByUserId, GETUTCDATE(),1,'AVAILABLE'
                   )
        END

    --Marco el NLU como pendiente de entrenamiento
    UPDATE
        [dbo].[NLU]
    SET
        [NeedTrain] = 1
    WHERE
            [VCC] = @VCC AND [AppId] = @AppId

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
