SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveEnvironment] (
	@VCC VARCHAR(50) = NULL,
	@Name VARCHAR(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@Description VARCHAR(200) = NULL,
	@FTPDirectory VARCHAR(MAX) = NULL,
	@ApiHost VARCHAR(50) = NULL,
	@ApiPort VARCHAR(50) = NULL,
	@ApiUser VARCHAR(50) = NULL,
	@ApiPassword VARCHAR(50) = NULL, 		
	@DbDisabled Bit = NULL,
	@DbServer VARCHAR(50) = NULL,
	@DbPort VARCHAR(50) = NULL,				
	@DbUser VARCHAR(50) = NULL,
	@DbPassword VARCHAR(50) = NULL,
	@PbxDisabled BIT = NULL, 				
	@PbxServer VARCHAR(50) = NULL,
	@PbxPort VARCHAR(50) = NULL,
	@PbxUser VARCHAR(50) = NULL,			
	@PbxPassword VARCHAR(50) = NULL,
	@CreatedDate DATETIME = NULL,
	@CreatedByUserId VARCHAR(50) = NULL, 	
	@LastModifiedDate DATETIME = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [Environment]
	SET [Type] = @Type,
		[Description] = @Description,
		[FTPDirectory] = @FTPDirectory,
		[ApiHost] = @ApiHost,
		[ApiPort] = @ApiPort,
		[ApiUser] = @ApiUser,
		[ApiPassword] = CASE WHEN @ApiPassword IS NULL THEN [ApiPassword] ELSE @ApiPassword END,
		[DbDisabled] = @DbDisabled,
		[DbServer] = @DbServer,
		[DbPort] = @DbPort,
		[DbUser] = @DbUser,
		[DbPassword] = CASE WHEN @DbPassword IS NULL THEN [DbPassword] ELSE @DbPassword END,
		[PbxDisabled] = @PbxDisabled,
		[PbxServer] = @PbxServer,
		[PbxPort] = @PbxPort,
		[PbxUser] = @PbxUser,
		[PbxPassword] = CASE WHEN @PbxPassword IS NULL THEN [PbxPassword] ELSE @PbxPassword END,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
	AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Environment] (
			[VCC], [Name], [Type], [FTPDirectory],
			[Description], [ApiHost], [ApiPort],
			[ApiUser], [ApiPassword], [DbDisabled],
			[DbServer],[DbPort],[DbUser], 
			[DbPassword], [PbxDisabled], [PbxServer],
			[PbxPort], [PbxUser],[PbxPassword],
			[CreatedDate], [CreatedByUserId], 
			[LastModifiedDate],[LastModifiedByUserId], 
			[TimeStamp]
			)
		VALUES (
			@VCC, @Name, @Type, @FTPDirectory,
			@Description, @ApiHost, @ApiPort,
			@ApiUser, @ApiPassword, @DbDisabled, 
			@DbServer,@DbPort,@DbUser, 
			@DbPassword, @PbxDisabled, @PbxServer,
			@PbxPort, @PbxUser, @PbxPassword,
			@CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, 
			GETUTCDATE()
		)
	END

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
