SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveEvaluationTipificationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL
) AS
BEGIN
	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	;WITH CTE_TIPIFICATION_QUERY AS (
		SELECT DISTINCT HA.[ID]							'AbilityId',
							HEFASTQ.*
			FROM [dbo].[HistoricAbility] HA (NOLOCK)
			INNER JOIN [dbo].[HistoricScore] HS (NOLOCK)
				ON HS.[VCC] = HA.[VCC]
					AND HS.[EvaluationPlanId] = HA.[EvaluationPlanId]
					AND HS.[IdAbility] = HA.[ID]
					/*
			INNER JOIN [dbo].[HistoricEvaluationFormatAbilityScoreTipification] HEFAST (NOLOCK)
				ON HEFAST.[VCC] = HA.[VCC]
					AND HEFAST.[EvaluationPlanId] = HS.[EvaluationPlanId]
					AND HEFAST.[ScoreId] = HS.[ID]
					*/
			INNER JOIN [dbo].[HistoricEvaluationFormatAbilityScoreTipificationQuery] HEFASTQ (NOLOCK)
				ON HEFASTQ.[VCC] = HA.[VCC]
					AND HEFASTQ.[EvaluationPlanId] = HS.[EvaluationPlanId]
					AND HEFASTQ.[ScoreId] = HS.[ID]
					--AND HEFASTQ.[TipificationId] = HEFAST.[ID]
			WHERE HA.[VCC] = @VCC
				AND HA.[EvaluationPlanId] = @EVALUATION_PLAN_ID
	) 
		
		-- GENERAMOS LOS REGISTROS DE TIPIFICACION PARA LAS INTERACCIONES CON 0 DE CALIFICACION Y NO ESTEN YA REGISTRADAS
		INSERT INTO [dbo].[EvaluationTipification] (
			[VCC], [AbilityId], [ScoreId], [ID], [EvaluationPlanId], 
			[InteractionId], [AuditorId], [CreatedDate], [CreatedByUserId]
		) 
			SELECT CTE_TQ.[VCC], CTE_TQ.[AbilityId], CTE_TQ.[ScoreId], CTE_TQ.[TipificationId], CTE_TQ.[EvaluationPlanId],
					AEP.[IdInteraction], 'SPEECH', GETUTCDATE(), 'system'
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				LEFT JOIN CTE_TIPIFICATION_QUERY CTE_TQ (NOLOCK)
					ON CTE_TQ.[VCC] = AEP.[Instance]
				LEFT JOIN [EvaluationTipification] ET (NOLOCK)
					ON ET.[VCC] = CTE_TQ.[VCC]
						AND ET.[AbilityId] = CTE_TQ.[AbilityId]
						AND ET.[ScoreId] = CTE_TQ.[ScoreId]
						AND ET.[ID] = CTE_TQ.[TipificationId]
						AND ET.[EvaluationPlanId] = CTE_TQ.[EvaluationPlanId]
						AND ET.[InteractionId] = AEP.[IdInteraction]
				WHERE AEP.[Instance] = @VCC
					AND AEP.[IdEvaluationPlan] = @EVALUATION_PLAN_ID
					AND AEP.[Score] = 0
					AND ET.[VCC] IS NULL
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
