SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveIntent] (
    @VCC					VARCHAR(50) = NULL,
    @Name					VARCHAR(50) = NULL,
    @IntentId				VARCHAR(50) = NULL,
    @AppId					VARCHAR(50) = NULL,
    @Color					VARCHAR(50) = NULL,
    @CreatedDate			DATETIME = NULL,
    @CreatedByUserId		VARCHAR(50) = NULL,
    @LastModifiedDate		DATETIME = NULL,
    @LastModifiedByUserId	VARCHAR(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

    UPDATE [Intent]
    SET [Name] = @Name,
        [CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
        [CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
        [LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
        [LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
        [TimeStamp] = GETUTCDATE()
    WHERE [VCC] = @VCC
      AND [Name] = @Name
      AND [AppId] = @AppId

    IF @@ROWCOUNT = 0
        BEGIN
            INSERT INTO [Intent] (
                [VCC], [Name], [IntentId], [AppId],
                [Color], [CreatedDate], [CreatedByUserId],
                [LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[Status],[StatusCode]
            )
            VALUES (
                       @VCC, @Name, @IntentId, @AppId,
                       @Color, @CreatedDate, @CreatedByUserId,
                       @LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(),1,'AVAILABLE'
                   )
        END

    --Marco el NLU como pendiente de entrenamiento
    UPDATE
        [dbo].[NLU]
    SET
        [NeedTrain] = 1
    WHERE
            [VCC] = @VCC AND [AppId] = @AppId

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
