SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveInteractionEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdCampaign Varchar(100) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@InteractionSection Int = 0,
	@InteractionPart Int = 0,
	@InteractionFolder VARCHAR(50) = NULL,
	@InteractionDateStart DateTime = '1980-01-01',
    @InteractionDateEnd DateTime = '2050-01-01',
	@InteractionType Varchar(50) = NULL,
	@TotalMessages INT = NULL,
	@InteractionDuration Int = 0,
	@InteractionOrigin Varchar(50) = NULL,
	@InteractionManagementResult Varchar(50) = NULL,
	@InteractionContactId Varchar(50) = NULL,
	@InteractionFormat Varchar(20) = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@LastModifiedDate DateTime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@CreatedDate DateTime = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DEPRECATED: REEMPLAZADO POR BULKINTERACTIONEVALUATIONPLAN
	IF(@InteractionManagementResult = '') SET @InteractionManagementResult = NULL;

	UPDATE [InteractionEvaluationPlan]
	SET
		[Instance] = @Instance, 
		[IdEvaluationPlan] = @IdEvaluationPlan, 
		[IdAgent] = @IdAgent,
		[IdCampaign] = @IdCampaign, 
		[IdInteraction] = @IdInteraction, 
		[InteractionSection] = @InteractionSection, 
		[InteractionPart] = @InteractionPart, 
		[InteractionDateStart] = @InteractionDateStart,
		[FormattedEndDate] = @InteractionFolder,
		[InteractionDateEnd] = @InteractionDateEnd, 
		[InteractionType] = @InteractionType, 
		[InteractionMessages] = @TotalMessages,
		[InteractionDuration] = @InteractionDuration,
		[InteractionOrigin] = @InteractionOrigin, 
		[ManagementResult] = @InteractionManagementResult, 
		[ContactId] = @InteractionContactId,
		[InteractionFormat] = @InteractionFormat,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[LastModifiedDate] = GETUTCDATE(),
		[TimeStamp] = GETUTCDATE()

		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND	[IdInteraction] = @IdInteraction
			AND	[InteractionSection] = @InteractionSection
			AND	[InteractionPart] = @InteractionPart

	IF @@ROWCOUNT = 0
		INSERT INTO [InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[IdCampaign], [IdInteraction], [FormattedEndDate], 
			[InteractionSection], [InteractionPart], [InteractionDateStart], 
			[InteractionDateEnd], [InteractionType], [InteractionMessages],
			[InteractionDuration], [InteractionOrigin], [ManagementResult], 
			[ContactId], [InteractionFormat], [CreatedByUserId], 
			[CreatedDate], [TimeStamp]
		)
		VALUES (
			@Instance, @IdEvaluationPlan, @IdAgent,
			@IdCampaign, @IdInteraction, @InteractionFolder,
			@InteractionSection, @InteractionPart, @InteractionDateStart, 
			@InteractionDateEnd, @InteractionType, @TotalMessages,
			@InteractionDuration, @InteractionOrigin, @InteractionManagementResult, 
			@InteractionContactId, @InteractionFormat, @CreatedByUserId, 
			@CreatedDate, GETUTCDATE()
		)

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
