SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveReport](
	@VCC Varchar(50) = NULL,				@ID Varchar(50) = NULL,					@Description Varchar(300) = NULL,
	@Procedure Varchar(50) = NULL,				@StartDate Datetime = NULL,				@EndDate Datetime = NULL,
	@Frecuency Varchar(50) = NULL,				@HourSpace Integer = NULL,				@ExactTime Varchar(50) = NULL,
	@Weekday Varchar(50) = NULL,				@DayMonth Varchar(50) = NULL,			@Summary Varchar(300) = NULL,
	@Filter Varchar(1000) = NULL,				@Email Varchar(1000) = NULL,			@CreatedDate Datetime = NULL,			
	@CreatedByUserId Varchar(50) = NULL,		@LastModifiedDate Datetime = NULL, 		@LastModifiedByUserId Varchar(50) = NULL,
	@Type Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [Report]
	SET [Description]	= @Description,
		[Procedure]		= @Procedure,
		[StartDate]		= @StartDate,
		[EndDate]		= @EndDate,
		[Frecuency]		= @Frecuency,
		[HourSpace]		= @HourSpace,
		[ExactTime]		= @ExactTime,
		[Weekday]		= @Weekday,
		[DayMonth]		= @DayMonth,
		[Summary]		= @Summary,
		[Filter]		= @Filter,
		[Email]			= @Email,
		[Type]			= @Type,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
	AND [ID] = @ID
    
    IF @@ROWCOUNT = 0
		INSERT INTO [Report] (
			[VCC], [ID], [Description],[Type],
            [Procedure], [StartDate],[EndDate],
            [Frecuency],[HourSpace],[ExactTime],
            [Weekday],[DayMonth],[Summary],
            [Filter], [Email], [CreatedDate],
            [CreatedByUserId],[LastModifiedDate],[LastModifiedByUserId],
            [TimeStamp]
        )
		VALUES (
			@VCC, @ID, @Description,@Type,
            @Procedure, @StartDate,@EndDate,
            @Frecuency, @HourSpace, @ExactTime,
            @Weekday, @DayMonth, @Summary,
            @Filter, @Email, @CreatedDate,
            @CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId,
            GETUTCDATE()
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
