SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveStudy] (
	@VCC Varchar(50) = NULL,
	@ProcessId Varchar(50) = NULL,
	@TemplateId Varchar(50) = NULL,
	@Name Varchar(200) = NULL,
	@Description Varchar(50) = NULL,
	@Status Float = NULL,
	@Type VARCHAR(50) = NULL,
	@BatchScheduleId VARCHAR(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Study]
		SET [Name] = @Name,
			[Description] = @Description,
			[Status] = @Status,
			[Type] = @Type,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ProcessId] = @ProcessId
			AND [TemplateId] =@TemplateId
			AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Study] (
			[VCC], [ProcessId], [TemplateId], 
			[Name], [Description], [Status],
			[Type],	[BatchScheduleId], [CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ProcessId, @TemplateId,
			@Name, @Description, @Status,
			@Type, @BatchScheduleId, @CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)
		EXEC [dbo].[SaveHistoricStudyData] @VCC,@Name,@TemplateId
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
