SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

-- [dbo].[SaveStudyStatus] 'inconcert', 'procesoallegro33', 'test_custom', 'Estudio_Prueba', 0, 'D234FD3D-6F5E-499C-942E-1AD5B92EE368', ''
CREATE PROCEDURE [dbo].[SaveStudyStatus]
(
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@TemplateId				VARCHAR(50),
	@StudyId				VARCHAR(200),
	@Status					FLOAT,
	@LastQueryId			VARCHAR(50),
	@ErrorMessage			VARCHAR(800),
	@LastModifiedDate		DATETIME,
	@LastModifiedByUserId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[Study] SET
			[Status] = @Status,
			[LastQueryId] = @LastQueryId,
			[ErrorMessage] = CASE WHEN @ErrorMessage = '' THEN NULL ELSE @ErrorMessage END,
			[LastModifiedDate] = @LastModifiedDate,
			[LastModifiedByUserId] = @LastModifiedByUserId,
			[TimeStamp] = GETUTCDATE()
		WHERE
			[VCC] = @VCC
			AND [ProcessId] = @ProcessId
			AND [TemplateId] = @TemplateId
			AND [Name] = @StudyId
	
	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL ESTUDIO PERTENECE A UNA AGENDA
	DECLARE @SCHEDULE_ID VARCHAR(50) = NULL

	-- OBTENEMOS EL ID DE AGENDA DEL ESTUDIO
	SELECT @SCHEDULE_ID = S.[BatchScheduleId]
		FROM [dbo].[Study] S (NOLOCK)
		WHERE S.[VCC] = @VCC 
			AND S.[Name] = @StudyId

	-- SI EL ESTUDIO PERTENECE A UNA AGENDA ACTUALIZAMOS
	IF @SCHEDULE_ID IS NOT NULL
	BEGIN
		-- ACTUALIZAMOS LA EJECUCION
		UPDATE [dbo].[BatchScheduleExecution]
			SET [Status] = 'BATCH_STARTED'
			WHERE [VCC] = @VCC
				AND [BatchScheduleId] = @SCHEDULE_ID
				AND [BatchId] = @StudyId
	END


	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
