SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveTipificationQuery] (
	@VCC							VARCHAR(50) = NULL,
	@TipificationId					VARCHAR(50) = NULL,
	@QueryId						VARCHAR(50) = NULL,
	@QueryContent					VARCHAR(1000) = NULL,
	@AcceptancePercentage			DECIMAL(18, 2) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- ACTUALIZAMOS EL REGISTRO EN CASO YA EXISTA
	UPDATE [TipificationQuery]
		SET [QueryId] = @QueryId,
			[QueryContent] = @QueryContent,
			[AcceptancePercentage] = @AcceptancePercentage,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [TipificationId] = @TipificationId

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [TipificationQuery] (
			[VCC], [TipificationId], [QueryId], 
			[QueryContent], [AcceptancePercentage], [TimeStamp]
		)
		VALUES (
			@VCC, @TipificationId, @QueryId, 
			@QueryContent, @AcceptancePercentage, GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
