SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [SaveTranscription] 'default', 'F040EA5A-E455-49EC-8A8D-4A4AD13D8786', 'FFB04B5FF6E242098CD31F419CC4E4A3', 0, 0, 2, 'admin'
CREATE PROCEDURE [dbo].[SaveTranscription]
(
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@Section NUMERIC(5, 0),
	@Part NUMERIC(5, 0),
	@Campaign VARCHAR(100) = NULL,
	@Folder VARCHAR(50) = NULL,
	@ID VARCHAR(50) = NULL,
	@Value INT,
	@UserId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI EL INTERACTIONTYPE ES NULL SETTEAMOS CALL POR DEFECTO
	IF @InteractionType IS NULL SET @InteractionType = 'CALL'

	UPDATE [dbo].[Transcription] SET
	[Value] = @Value,
	[LastModifiedDate] = GETUTCDATE(),
	[LastModifiedByUserId] = @UserId
	WHERE
		[VCC] = @VCC 
		AND [ProcessId] = @ProcessId 
		AND [InteractionType] = @InteractionType
		AND (
			(
				[InteractionType] = 'CALL'
					AND [Section] = @Section 
					AND [Part] = @Part 
			) OR (
				[InteractionType] <> 'CALL'
					AND [Folder] = @Folder
					AND [Campaign] = @Campaign
			)
		)
		AND [ID] = @ID

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Transcription](
			[VCC],
			[ProcessId],
			[InteractionType],
			[Section],
			[Part],
			[Campaign],
			[Folder],
			[ID],
			[Value],
			[CreatedByUserId]
		)
		VALUES(
			@VCC,
			@ProcessId,
			@InteractionType,
			@Section,
			@Part,
			@Campaign,
			@Folder,
			@ID,
			@Value,
			@UserId
		)
	END

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
