CREATE TABLE [dbo].[EvaluationResult] (
   [Instance] [varchar](50) NOT NULL ,
   [IdCampaign] [varchar](50) NOT NULL ,
   [IdInteraction] [varchar](250) NOT NULL ,
   [IdAgent] [varchar](50) NOT NULL ,
   [IdEvaluationFormat] [varchar](50) NOT NULL ,
   [MinQualificationAcceptable] [numeric](5,2) NOT NULL  ,
   [IdGroup] [varchar](50) NULL ,
   [IdSubGroup] [varchar](50) NULL ,
   [IdAbility] [varchar](50) NOT NULL ,
   [Qualification] [numeric](5,2) NOT NULL  ,
   [OwnScore] [numeric](5,2) NULL 
      CONSTRAINT [DF_EvaluationResult_Ownscore] DEFAULT ((0)) ,
   [InheritedScore] [numeric](5,2) NULL 
      CONSTRAINT [DF_EvaluationResult_InheritedScore] DEFAULT ((0)) ,
   [IdEvaluator] [varchar](50) NOT NULL ,
   [EvaluationDate] [datetime] NULL   ,
   [MaxAbilityScore] [numeric](5,2) NOT NULL  ,
   [AbilityInnerScore] [numeric](5,2) NULL  ,
   [IdEvaluationPlan] [varchar](50) NOT NULL 
      CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7] DEFAULT ((0)),
   [CreatedDate] [datetime] NULL   ,
   [CreatedByUserId] [varchar](50) NULL ,
   [LastModifiedDate] [datetime] NULL   ,
   [LastModifiedByUserId] [varchar](50) NULL ,
   [TimeStamp] [datetime] NULL   ,
   [Comment] [varchar](1000) NULL ,
   [NotApplies] [bit] NULL   ,
   [ScoreDescription] [varchar](100) NOT NULL 
      CONSTRAINT [DF__Evaluatio__Score__3EDC53F0] DEFAULT (''),
   [CampaignDescription] [varchar](100) NULL ,
   [AgentDescription] [varchar](100) NULL ,
   [InteractionDateini] [datetime] NULL   ,
   [InteractionDatefin] [datetime] NULL   ,
   [InteractionAddress] [varchar](200) NULL 
      CONSTRAINT [DF__Evaluatio__Inter__3FD07829] DEFAULT (''),
   [AbilityOrder] [numeric](4,0) NULL  ,
   [InteractionType] [varchar](50) NULL ,
   [IdAbilityEvaluationFormat] [varchar](50) NOT NULL ,
   [IdAuditor] [varchar](50) NOT NULL ,
   [Conditional] [varchar](50) NULL 

   ,CONSTRAINT [PK_EvaluationResult] PRIMARY KEY CLUSTERED ([Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [IdAgent], [IdAbilityEvaluationFormat])
)

CREATE  NONCLUSTERED INDEX [ReportByDetailAgent_01] ON [dbo].[EvaluationResult] ([Instance], [AgentDescription], [IdAuditor], [CampaignDescription])

GO
